angular.module("tools", []).value("ServerConfig", {
  innerAppVersion : "1.1.1",
  isHotUpdate : 0,
  exServer : "http://app.xinbafar.com.cn:8080/business",
  webServer : "http://app.xinbafar.com.cn:8080/business",
  imgServer : "http://app.xinbafar.com.cn:8080/business",
  tmsServer : "http://app.xinbafar.com.cn:8080/business/tms/mall/cid/",
  mgrServer : "http://app.xinbafar.com.cn:8080/business/mgr",
  mmsServer : "http://app.xinbafar.com.cn:8080/business/mms",
  esServer : "http://app.xinbafar.com.cn:8080/business/es",
  versionServer : "",
  currentServer : "",
  jpushIdPrefix : "USERID_",
  jpushCidPrefix : "CID_",
  printLineByteSize : 48,
  taobaoKey : "0000000000",
  appScheme : "StarBusiness",
  userConfigData : [],
  currencySymbol : "￥",
  companyConfigData : {},
  commonConfig : {},
  salerSize : 6
}).factory("ServerType", ["ServerConfig", function(context) {
  /**
   * @return {?}
   */
  function isEX() {
    return context.currentServer === context.exServer;
  }
  return{
    /** @type {function (): ?} */
    isEX : isEX
  };
}]).constant("BusinessConstant", {
  CUSTOMERPOINT : {
    ON : 1,
    OFF : 2
  },
  ZEROPAID : {
    ON : 1,
    OFF : 2
  },
  INTERNATIONALCODES : [{
    val : "",
    text : "中国大陆",
    code : "+86"
  }, {
    val : "00852",
    text : "中国香港特别行政区",
    code : "+852"
  }, {
    val : "00853",
    text : "中国澳门特别行政区",
    code : "+853"
  }, {
    val : "00886",
    text : "台湾",
    code : "+886"
  }, {
    val : "0082",
    text : "韩国",
    code : "+82"
  }, {
    val : "0081",
    text : "日本",
    code : "+81"
  }, {
    val : "0060",
    text : "马来西亚",
    code : "+60"
  }, {
    val : "0061",
    text : "澳大利亚",
    code : "+61"
  }, {
    val : "0064",
    text : "新西兰",
    code : "+64"
  }, {
    val : "0065",
    text : "新加坡",
    code : "+65"
  }, {
    val : "001",
    text : "美国",
    code : "+1"
  }, {
    val : "001",
    text : "加拿大",
    code : "+1"
  }, {
    val : "0039",
    text : "意大利",
    code : "+39"
  }, {
    val : "0044",
    text : "英国",
    code : "+44"
  }]
}).constant("NameConstant", {
  HOMEPAGE : "首页",
  MENU : "菜单",
  PURCHASE : "进货",
  KEY329 : "进货单",
  KEY220 : "进货历史",
  PURCHASERETURN : "进货退货",
  KEY330 : "进货退货单",
  KEY107 : "进货退货历史",
  KEY208 : "供应商信息",
  SUPPLIERADD : "新增供应商",
  KEY331 : "供应商管理",
  KEY255 : "供应商对账",
  KEY136 : "供应商对账单",
  WHOLESALE : "销售",
  KEY332 : "销售单",
  KEY333 : "销售历史",
  WHOLESALERETURN : "销售退货",
  KEY334 : "销售退货单",
  KEY335 : "销售退货历史",
  KEY258 : "零售单历史",
  KEY257 : "零售单",
  STORE : "库存",
  KEY336 : "盘点单",
  KEY337 : "盘点历史",
  KEY338 : "库存查询",
  STOCKWARN : "单品库存预警",
  STORESTOCKDETAIL : "商品库存",
  KEY177 : "仓库管理",
  STOREHOUSEADD : "新增仓库",
  KEY176 : "仓库信息",
  STORETRANSFRER : "库存调拨",
  KEY339 : "库存调拨单",
  KEY340 : "库存调拨历史",
  CLIENT : "客户",
  KEY268 : "客户信息",
  CLIENTADD : "新增客户",
  KEY341 : "客户管理",
  KEY350 : "客户对账",
  CLIENTMACCRECORD : "客户对账单",
  GOOD : "商品",
  KEY291 : "商品信息",
  GOODADD : "新增商品",
  KEY342 : "商品管理",
  GOODNAV : "商品详情",
  CHART : "报表",
  KEY343 : "统计图表",
  KEY198 : "经营概况",
  CHARTSTORERATE : "库存分析",
  CHARTPROFITRATE : "利润分析",
  FINANCE : "财务",
  KEY349 : "账户流水",
  KEY072 : "账户流水",
  ACCOUNTTOTAL : "账户汇总",
  KEY238 : "结算账户管理",
  ACCOUNTADD : "新增账户",
  KEY237 : "结算账户",
  KEY159 : "账目类型管理",
  ACCOUNTITEMADD : "新增类型",
  KEY158 : "账目类型",
  KEY160 : "账户互转",
  SETTING : "设置",
  KEY196 : "个人信息",
  KEY187 : "修改密码",
  KEY221 : "打印设置",
  COMPANYCONFIG : "系统参数",
  USERMANMGNT : "员工管理",
  KEY252 : "员工编辑",
  USERMANADD : "新增员工",
  KEY303 : "关于",
  HELP : "帮助中心",
  SETTINGANDHELP : "设置",
  KEY161 : "快捷菜单",
  SCAN : "扫一扫",
  MESSAGE : "消息中心",
  TMS : "店铺",
  TMSDETAIL : "我的销货宝",
  KEY212 : "销货宝订单",
  KEY213 : "销货宝代收交易",
  TMSORDER : "销货宝订单",
  KEY344 : "进货报表",
  KEY345 : "销售报表",
  KEY346 : "盘点报表",
  KEY134 : "盘点明细",
  SUMBYSTOREORDER : "按盘点单汇总",
  SUMBYSTOREHOUSE : "按仓库汇总",
  KEY067 : "进货明细",
  KEY144 : "销售明细",
  SUMBYSKU : "按单品汇总",
  SUMBYGOODS : "按商品汇总",
  SUMBYORDER : "按单据汇总",
  SUMBYCLIENT : "按客户汇总",
  SUMBYSALEMAN : "按销售员汇总",
  SUMBYSALERCOMSTORE : "按销售员所属部门汇总",
  SUMBYSTOREHOUSECOMSTORE : "按仓库所属部门汇总",
  SUMBYSUPPLIER : "按供应商汇总",
  SUMBYPURCHASEMAN : "按进货员汇总",
  KEY348 : "进销对比",
  KEY165 : "库存流水",
  WEIDIANFORYOU : "立刻拥有销货宝!",
  KEY262 : "网店管理",
  KEY289 : "库存商品",
  KEY319 : "上架商品",
  MEMBERMGT : "会员管理",
  MEMBERINFO : "会员信息",
  KEY351 : "物流管理",
  DELIVERYEDIT : "物流信息",
  DELIVERYADD : "新增物流",
  PAYMENT : "增值服务",
  KEY276 : "有奖活动",
  KEY218 : "打印条码",
  VERSIONUPDATE : "版本历史",
  FLYSTARBBS : "丝圈社区",
  KEY200 : "用户配置",
  KEY290 : "意见反馈",
  VOUCHER : "代金券",
  KEY250 : "系统重置",
  KEY169 : "计客宝",
  PARTNER : "合作伙伴",
  KEY201 : "合作客户",
  KEY166 : "合作供应商",
  BUSINESSCOMMUNITYMAIN : "生意圈",
  BULLETINMANMGNT : "公告列表",
  BULLETI : "公司公告",
  KEY347 : "调拨报表",
  KEY055 : "调拨明细",
  SUMBYTRANSFERORDER : "按调拨单汇总",
  KEY352 : "快递单打印",
  PUBROLEMGMT : "角色管理",
  PUBROLEINFO : "角色信息",
  ECOMMERCE : "电商接口",
  SHOPADD : "新增店铺",
  TAOBAOORDERLIST : "淘宝订单",
  CASH : "快速收款",
  PAYMENTSETTINGS : "支付设置",
  SHIPPINGSETTINGS : "运费设置",
  PRIVACY : "隐私政策",
  SIGNIN : "签到定位",
  SIGNINQUERY : "签到查询",
  SIGNINCOUNT : "签到统计"
}).constant("AuthorityConstant", {
  GOODMAN : "goods",
  PURCHASEMAN : "purchase",
  SALEMAN : "sale",
  STOREMAN : "storehouse",
  CLIENTMAN : "client",
  CHARTMAN : "totalSaleReport",
  FINANCEMAN : "finance",
  WECHATMAN : "shop",
  APP_SHOP : 2,
  APP_ASSOCIATOR : 3
}).factory("ReportConstant", ["$state", function($state) {
  return{
    echartsTheme : {
      backgroundColor : "#FCFCFC",
      color : ["#ff6600", "#E42B6D", "#F4E24E", "#FE9616", "#8AED35", "#ff69b4", "#ba55d3", "#cd5c5c", "#ffa500", "#40e0d0", "#E95569", "#ff6347", "#7b68ee", "#00fa9a", "#ffd700", "#6699FF", "#ff6666", "#3cb371", "#b8860b", "#30e0e0"]
    },
    reportLevel : [{
      val : 1,
      text : "优秀"
    }, {
      val : 2,
      text : "良好"
    }, {
      val : 3,
      text : "有待提高"
    }],
    /**
     * @param {Object} $scope
     * @return {?}
     */
    actionSheet : function($scope) {
      return{
        buttons : [{
          text : '<i class="icon ion-ios-pulse assertive"></i> 销量走势'
        }, {
          text : '<i class="icon ion-ios-analytics-outline assertive"></i> 毛利分析'
        }, {
          text : '<i class="icon ion-ios-analytics-outline assertive"></i> 动销率'
        }, {
          text : '<i class="icon ion-ios-analytics-outline assertive"></i> 周转率'
        }],
        /**
         * @param {?} clicked
         * @return {?}
         */
        buttonClicked : function(clicked) {
          switch($scope.viewReplace(), clicked) {
            case 0:
              $state.go("eventmenu.KEY170");
              break;
            case 1:
              $state.go("eventmenu.KEY035");
              break;
            case 2:
              $state.go("eventmenu.KEY074");
              break;
            case 3:
              $state.go("eventmenu.KEY139");
          }
          return true;
        }
      };
    }
  };
}]).factory("OrderType", [function() {
  var typeName = {};
  /** @type {number} */
  var getterName = 1;
  /** @type {number} */
  var setterName = 2;
  /** @type {number} */
  var methodName = 3;
  /** @type {number} */
  var unlock = 4;
  /** @type {number} */
  var frontName = 5;
  /** @type {number} */
  var callbackSymbol = 6;
  /** @type {number} */
  var strValue = 7;
  /** @type {number} */
  var docUid = 21;
  /** @type {number} */
  var objUid = 22;
  /** @type {number} */
  var fnUid = 31;
  /** @type {number} */
  var nMod10 = 32;
  /** @type {number} */
  var instanceName = 33;
  return typeName[getterName] = "销售单", typeName[setterName] = "销售退货单", typeName[methodName] = "进货单", typeName[unlock] = "进货退货单", typeName[frontName] = "零售单", typeName[callbackSymbol] = "库存调拨单", typeName[strValue] = "客户对账单", typeName[docUid] = "收款单", typeName[objUid] = "快速收款单",
  typeName[fnUid] = "快递单", typeName[nMod10] = "电子面单", typeName[instanceName] = "电商平台订单", {
    saleOrder : getterName,
    saleReturnOrder : setterName,
    KEY329 : methodName,
    KEY330 : unlock,
    retailOrder : frontName,
    transferOrder : callbackSymbol,
    clientDebtBilling : strValue,
    receiptOrder : docUid,
    fastReceiptOrder : objUid,
    logisticsOrder : fnUid,
    eorder : nMod10,
    ehsopLogisticsOrder : instanceName,
    typeName : typeName
  };
}]).factory("PrintType", [function() {
  var self = {};
  /** @type {number} */
  var messageId = 1;
  /** @type {number} */
  var preserve = 2;
  /** @type {number} */
  var callbackSymbol = 3;
  return self[messageId] = "打印商品标签", self[preserve] = "打印商品二维码", self[callbackSymbol] = "打印小票", {
    printLabel : messageId,
    printQRCode : preserve,
    printTicket : callbackSymbol,
    printTypeName : self
  };
}]).factory("BalanceBusinessItem", [function() {
  /** @type {Array} */
  var getBusinessItem = [{
    val : 1,
    text : "期初余额"
  }, {
    val : 21,
    text : "进货单"
  }, {
    val : 22,
    text : "进货退货"
  }, {
    val : 23,
    text : "进货结算单"
  }, {
    val : 24,
    text : "供应商付款"
  }, {
    val : 31,
    text : "销售单"
  }, {
    val : 32,
    text : "销售退货"
  }, {
    val : 33,
    text : "销售结算"
  }, {
    val : 34,
    text : "客户收款"
  }, {
    val : 41,
    text : "零售单"
  }, {
    val : 51,
    text : "库存盘点单"
  }, {
    val : 52,
    text : "库存调整单"
  }, {
    val : 61,
    text : "库存调拔单"
  }];
  return{
    getBusinessItem : getBusinessItem
  };
}]).factory("VaApplyItem", [function() {
  /** @type {Array} */
  var getVaItem = [{
    htmlName : "/isAppHtml/m/va/collection.html",
    title : "公司代收服务"
  }, {
    htmlName : "",
    title : ""
  }, {
    htmlName : "/isAppHtml/m/va/KEY303-wd.html",
    title : "销货宝"
  }, {
    htmlName : "/isAppHtml/m/va/associatorRecharge.html",
    title : "进销存会员"
  }, {
    htmlName : "/isAppHtml/m/va/scanRecharge.html",
    title : "扫码支付"
  }, {
    htmlName : "/isAppHtml/m/va/customerPoints.html",
    title : "客户积分"
  }];
  return{
    getVaItem : getVaItem
  };
}]).factory("Tools", function() {
  /**
   * @param {?} qualifier
   * @return {?}
   */
  function isNum(qualifier) {
    /** @type {RegExp} */
    var isSimple = /^\d+(\.\d+)?$/;
    return isSimple.test(qualifier);
  }
  /**
   * @param {?} o
   * @return {?}
   */
  function isArray(o) {
    return Array.isArray ? Array.isArray(o) : "[object Array]" === Object.prototype.toString.call(o);
  }
  /**
   * @param {?} name
   * @return {?}
   */
  function FIsNull(name) {
    return null === name || (void 0 === name || name !== name);
  }
  /**
   * @param {string} value
   * @return {?}
   */
  function toStr(value) {
    return FIsNull(value) ? "" : value + "";
  }
  /**
   * @param {Object} obj
   * @param {string} prop
   * @return {?}
   */
  function hasOwn(obj, prop) {
    return Object.prototype.hasOwnProperty.call(obj, prop);
  }
  /**
   * @param {?} obj
   * @return {?}
   */
  function isEmpty(obj) {
    if (obj) {
      var key;
      for (key in obj) {
        return!hasOwn(obj, key);
      }
    }
    return true;
  }
  /**
   * @param {string} a
   * @param {string} p
   * @return {?}
   */
  function require(a, p) {
    return-1 != indexOf(a, p);
  }
  /**
   * @param {string} name
   * @param {string} o
   * @return {?}
   */
  function indexOf(name, o) {
    if (name.indexOf) {
      return name.indexOf(o);
    }
    /** @type {number} */
    var i = 0;
    for (;i < name.length;i++) {
      if (o === name[i]) {
        return i;
      }
    }
    return-1;
  }
  /**
   * @param {?} arr
   * @param {string} value
   * @return {?}
   */
  function contains(arr, value) {
    if (angular.isArray(arr)) {
      /** @type {number} */
      var i = 0;
      for (;i < arr.length;i++) {
        if (angular.equals(arr[i], value)) {
          return true;
        }
      }
    }
    return false;
  }
  /**
   * @param {Array} items
   * @param {?} key
   * @param {?} node
   * @return {?}
   */
  function add(items, key, node) {
    if (angular.isArray(items)) {
      /** @type {number} */
      var i = 0;
      for (;i < items.length;i++) {
        if (angular.equals(items[i][key], node)) {
          return true;
        }
      }
    }
    return false;
  }
  /**
   * @param {number} body
   * @param {number} opt_attributes
   * @return {?}
   */
  function parseTime(body, opt_attributes) {
    var a;
    var b;
    /** @type {number} */
    var i = 0;
    /** @type {number} */
    var n = 0;
    try {
      i = body.toString().split(".")[1].length;
    } catch (e) {
    }
    try {
      n = opt_attributes.toString().split(".")[1].length;
    } catch (e) {
    }
    with(Math) {
      return a = Number(body.toString().replace(".", "")), b = Number(opt_attributes.toString().replace(".", "")), accMul(a / b, pow(10, n - i));
    }
  }
  /**
   * @param {?} val
   * @param {?} opt_attributes
   * @return {?}
   */
  function accMul(val, opt_attributes) {
    /** @type {number} */
    var i = 0;
    var qs = val.toString();
    var requestUrl = opt_attributes.toString();
    try {
      i += qs.split(".")[1].length;
    } catch (o) {
    }
    try {
      i += requestUrl.split(".")[1].length;
    } catch (o) {
    }
    return Number(qs.replace(".", "")) * Number(requestUrl.replace(".", "")) / Math.pow(10, i);
  }
  /**
   * @param {number} value
   * @param {?} dataAndEvents
   * @return {?}
   */
  function accAdd(value, dataAndEvents) {
    var l;
    var r2;
    var pow;
    var digits;
    try {
      l = value.toString().split(".")[1].length;
    } catch (i) {
      /** @type {number} */
      l = 0;
    }
    try {
      r2 = dataAndEvents.toString().split(".")[1].length;
    } catch (i) {
      /** @type {number} */
      r2 = 0;
    }
    return pow = Math.pow(10, Math.max(l, r2)), digits = l >= r2 ? l : r2, parseFloat(((value * pow + dataAndEvents * pow) / pow).toFixed(digits));
  }
  /**
   * @param {?} obj
   * @param {?} result
   * @return {?}
   */
  function log(obj, result) {
    var l;
    var r2;
    var scale;
    var NUMBER_OF_DECIMALS;
    try {
      l = obj.toString().split(".")[1].length;
    } catch (i) {
      /** @type {number} */
      l = 0;
    }
    try {
      r2 = result.toString().split(".")[1].length;
    } catch (i) {
      /** @type {number} */
      r2 = 0;
    }
    return scale = Math.pow(10, Math.max(l, r2)), NUMBER_OF_DECIMALS = l >= r2 ? l : r2, ((obj * scale - result * scale) / scale).toFixed(NUMBER_OF_DECIMALS);
  }
  /**
   * @param {?} value
   * @return {?}
   */
  function checkType(value) {
    /** @type {string} */
    var aType = typeof value;
    return null === value ? "null" : isArray(value) ? "array" : aType;
  }
  /**
   * @param {?} str
   * @param {boolean} strict
   * @return {?}
   */
  function trim(str, strict) {
    return toStr(str).replace(strict ? /\s+/g : / +/g, " ").replace(/^\s+/, "").replace(/\s+$/, "");
  }
  /**
   * @param {Object} obj
   * @param {?} iterator
   * @param {?} context
   * @param {?} arrayLike
   * @param {?} args
   * @return {undefined}
   */
  function each(obj, iterator, context, arrayLike, args) {
    var i;
    var l;
    var key;
    if (iterator = iterator || angular.noop, obj) {
      if (arrayLike || isArray(obj)) {
        if (args) {
          /** @type {number} */
          i = obj.length - 1;
          for (;i >= 0;i--) {
            if (iterator.call(context, obj[i], i, obj) === breaker) {
              return;
            }
          }
        } else {
          /** @type {number} */
          i = 0;
          l = obj.length;
          for (;l > i;i++) {
            if (iterator.call(context, obj[i], i, obj) === breaker) {
              return;
            }
          }
        }
      } else {
        for (key in obj) {
          if (hasOwn(obj, key) && iterator.call(context, obj[key], key, obj) === breaker) {
            return;
          }
        }
      }
    }
  }
  /**
   * @param {(Object|string)} obj
   * @param {?} iterator
   * @param {?} context
   * @return {?}
   */
  function some(obj, iterator, context) {
    /** @type {boolean} */
    var result = false;
    /** @type {function (this:(Array.<T>|string|{length: number}), (function (this:S, T, number, Array.<T>): ?|null), S=): boolean} */
    var nativeSome = Array.prototype.some;
    return iterator = iterator || angular.noop, obj ? nativeSome && obj.some === nativeSome ? obj.some(iterator, context) : (each(obj, function(value, index, list) {
      return result = iterator.call(context, value, index, list), result ? breaker : void 0;
    }), !!result) : result;
  }
  /**
   * @param {?} replacementHash
   * @param {?} opt_attributes
   * @return {?}
   */
  function union(replacementHash, opt_attributes) {
    var type = checkType(replacementHash);
    return void 0 === opt_attributes && (opt_attributes = replacementHash, replacementHash = "object" === type ? {} : []), type === checkType(opt_attributes) && ("object" === type || "array" === type ? each(opt_attributes, function(x, i) {
      var type = checkType(x);
      if ("object" === type || "array" === type) {
        replacementHash[i] = type === checkType(replacementHash[i]) ? replacementHash[i] : "object" === type ? {} : [];
        union(replacementHash[i], x);
      } else {
        replacementHash[i] = "function" === type ? null : x;
      }
    }) : replacementHash = "function" === type ? null : opt_attributes), replacementHash;
  }
  /**
   * @param {number} timeOutMillis
   * @return {?}
   */
  function randomInt(timeOutMillis) {
    var maxtimeOutMillis = timeOutMillis ? timeOutMillis : 1E6;
    return parseInt(Math.random() * maxtimeOutMillis + 1);
  }
  /**
   * @param {Array} a
   * @param {Object} b
   * @return {?}
   */
  function intersect(a, b) {
    var type = checkType(a);
    if (type === checkType(b) && ("array" === type || "object" === type)) {
      if (isEmpty(a)) {
        union(a, b);
      } else {
        if ("array" === type && 1 === a.length) {
          var o = a[0];
          var key = checkType(o);
          /** @type {number} */
          a.length = 0;
          if ("function" !== key) {
            each(b, function(x) {
              var type = checkType(x);
              if ("null" === key || key === type) {
                a.push("object" === key || "array" === key ? intersect(union(o), x) : union(x));
              }
            });
          }
        } else {
          each(a, function(value, i) {
            var string = checkType(value);
            if ("array" === type || hasOwn(b, i)) {
              if ("function" === string && "array" === type) {
                /** @type {null} */
                a[i] = null;
              } else {
                if ("null" === string) {
                  a[i] = union(b[i]);
                } else {
                  if (string === checkType(b[i])) {
                    if ("object" === string || "array" === string) {
                      intersect(a[i], b[i]);
                    } else {
                      a[i] = b[i];
                    }
                  } else {
                    delete a[i];
                  }
                }
              }
            } else {
              delete a[i];
            }
          });
        }
      }
    }
    return a;
  }
  /**
   * @param {?} tail
   * @param {?} s
   * @param {string} id
   * @param {string} ss
   * @return {?}
   */
  function FidStringToObjectArray(tail, s, id, ss) {
    var branchDataJSON = s.split(ss);
    /** @type {Array} */
    var removed = [];
    if (FIsNull(tail)) {
      return removed;
    }
    /** @type {number} */
    var i = 0;
    for (;i < tail.length;i++) {
      /** @type {number} */
      var conditionIndex = 0;
      for (;conditionIndex < branchDataJSON.length;conditionIndex++) {
        if (branchDataJSON[conditionIndex] == tail[i][id]) {
          removed.push(tail[i]);
          break;
        }
      }
    }
    return removed;
  }
  /**
   * @param {?} value
   * @param {string} key
   * @param {string} expected
   * @return {?}
   */
  function FfnCheckGtoreQty(value, key, expected) {
    if (angular.isArray(value)) {
      /** @type {number} */
      var ii = 0;
      for (;ii < value.length;ii++) {
        if (angular.equals(value[ii][key], expected)) {
          return value[ii];
        }
      }
    }
    return void 0;
  }
  /**
   * @param {?} obj
   * @param {?} opt_attributes
   * @return {?}
   */
  function FgetObjectByObject(obj, opt_attributes) {
    var n;
    if (angular.isArray(obj)) {
      /** @type {number} */
      var i = 0;
      for (;i < obj.length;i++) {
        /** @type {boolean} */
        n = true;
        var j;
        for (j in opt_attributes) {
          if (!angular.equals(obj[i][j], opt_attributes[j])) {
            /** @type {boolean} */
            n = false;
            break;
          }
        }
        if (n) {
          return obj[i];
        }
      }
    }
    return void 0;
  }

  //用于多单位比较
  function FgetObjectByObjectMultUnit(obj, opt_attributes) {
    var n;
    if (angular.isArray(obj)) {
      /** @type {number} */
      var i = 0;
      for (;i < obj.length;i++) {
        /** @type {boolean} */
        n = true;
        var j;
        for (j in opt_attributes) {
          if (!angular.equals(obj[i][j], opt_attributes[j])) {
            /** @type {boolean} */
            n = false;
            break;
          }
        }
        if (n) {
          return obj[i];
        }
      }
    }
    return void 0;
  }
  /**
   * @param {Array} obj
   * @param {string} key
   * @param {?} recurring
   * @return {?}
   */
  function FgetObjectList(obj, key, recurring) {
    /** @type {Array} */
    var values = [];
    if (angular.isArray(obj)) {
      /** @type {number} */
      var i = 0;
      for (;i < obj.length;i++) {
        if (angular.equals(obj[i][key], recurring)) {
          values.push(obj[i]);
        }
      }
    }
    return values;
  }
  /**
   * @param {Array} codeSegments
   * @param {string} j
   * @param {string} options
   * @return {?}
   */
  function FobjectArrayToIdString(codeSegments, j, options) {
    /** @type {string} */
    var d = "";
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      d += i == codeSegments.length - 1 ? codeSegments[i][j] : codeSegments[i][j] + options;
    }
    return d;
  }
  /**
   * @param {string} speed
   * @param {string} type
   * @param {string} position
   * @return {undefined}
   */
  function FtoastShow(speed, type, position) {
    if (void 0 === type) {
      /** @type {string} */
      type = "short";
    }
    if (void 0 === position) {
      /** @type {string} */
      position = "bottom";
    }
    if (window.plugins && window.plugins.toast) {
      window.plugins.toast.hide();
      window.plugins.toast.show(speed, type, position);
    } else {
      console.log("toast插件未定义！");
    }
  }
  /**
   * @param {Object} hash
   * @param {Array} opt_attributes
   * @return {?}
   */
  function FgetPropertyObj(hash, opt_attributes) {
    var obj = {};
    var i;
    for (i in opt_attributes) {
      if (hash.hasOwnProperty(opt_attributes[i])) {
        obj[opt_attributes[i]] = hash[opt_attributes[i]];
      }
    }
    return obj;
  }
  /**
   * @return {?}
   */
  function getWindowSize() {
    /** @type {number} */
    var viewportheight = 0;
    /** @type {number} */
    var viewportwidth = 0;
    return "number" == typeof window.innerWidth ? (viewportheight = window.innerHeight, viewportwidth = window.innerWidth) : document.documentElement && (document.documentElement.clientWidth || document.documentElement.clientHeight) ? (viewportheight = document.documentElement.clientHeight, viewportwidth = document.documentElement.clientWidth) : document.body && ((document.body.clientWidth || document.body.clientHeight) && (viewportheight = document.body.clientHeight, viewportwidth = document.body.clientWidth)),
    [viewportwidth, viewportheight];
  }
  /**
   * @return {undefined}
   */
  function FkeyboardShow() {
    if (window.cordova) {
      if (window.cordova.plugins) {
        if (window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.show();
        }
      }
    }
  }
  /**
   * @return {undefined}
   */
  function FkeyboardHide() {
    if (window.cordova) {
      if (window.cordova.plugins) {
        if (window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.close();
        }
      }
    }
  }
  /**
   * @param {string} attributes
   * @param {Function} recurring
   * @param {string} callback
   * @param {Object} post_content_type
   * @return {undefined}
   */
  function FshowAlert(attributes, recurring, callback, post_content_type) {
    if (window.cordova) {
      if (window.cordova.plugins) {
        if (ionic.Platform.isAndroid()) {
          if (null == attributes || "" == attributes) {
            /** @type {string} */
            attributes = callback;
            /** @type {string} */
            callback = "提示";
          }
        }
        if (null == callback) {
          /** @type {string} */
          callback = "提示";
        }
        if (null == post_content_type) {
          /** @type {string} */
          post_content_type = "确定";
        }
        navigator.notification.alert(attributes, recurring, callback, post_content_type);
      }
    }
  }
  /**
   * @param {string} str
   * @param {Function} loseX
   * @param {string} recurring
   * @param {Array} opt_attributes
   * @return {undefined}
   */
  function FshowConfirm(str, loseX, recurring, opt_attributes) {
    if (window.cordova) {
      if (window.cordova.plugins) {
        if (ionic.Platform.isAndroid()) {
          if (null == str || "" == str) {
            /** @type {string} */
            str = recurring;
            /** @type {string} */
            recurring = "提示";
          }
        }
        if (null == recurring) {
          /** @type {string} */
          recurring = "提示";
        }
        navigator.notification.confirm(str, loseX, recurring, opt_attributes);
      }
    }
  }
  /**
   * @param {string} v00
   * @param {Function} opts
   * @param {string} cb
   * @param {Array} opt_attributes
   * @param {number} recurring
   * @return {undefined}
   */
  function FshowPrompt(v00, opts, cb, opt_attributes, recurring) {
    if (window.cordova) {
      if (window.cordova.plugins) {
        navigator.notification.prompt(v00, opts, cb, opt_attributes, recurring);
      }
    }
  }
  /**
   * @param {string} src
   * @param {string} format
   * @param {boolean} darker
   * @return {?}
   */
  function FversionCompare(src, format, darker) {
    if (src = String(src), format = String(format), src === format) {
      return 0;
    }
    /** @type {Array.<string>} */
    var a = src.split(".");
    /** @type {Array.<string>} */
    var b = format.split(".");
    var l = Math[darker ? "max" : "min"](a.length, b.length);
    /** @type {number} */
    var i = 0;
    for (;l > i;i++) {
      if (a[i] = "undefined" == typeof a[i] ? 0 : parseInt(a[i], 10), b[i] = "undefined" == typeof b[i] ? 0 : parseInt(b[i], 10), a[i] > b[i]) {
        return 1;
      }
      if (a[i] < b[i]) {
        return-1;
      }
    }
    return 0;
  }
  /**
   * @param {number} type
   * @param {?} tagName
   * @param {number} opt_attributes
   * @return {?}
   */
  function FisInDays(type, tagName, opt_attributes) {
    var key = type + 24 * opt_attributes * 3600 * 1E3;
    return key >= tagName;
  }
  /**
   * @param {Date} date
   * @param {Date} format
   * @return {?}
   */
  function formatDate(date, format) {
    if (void 0 === format) {
      /** @type {Date} */
      format = date;
      /** @type {Date} */
      date = new Date;
    }
    var replacers = {
      M : date.getMonth() + 1,
      d : date.getDate(),
      h : date.getHours(),
      m : date.getMinutes(),
      s : date.getSeconds(),
      q : Math.floor((date.getMonth() + 3) / 3),
      S : date.getMilliseconds()
    };
    return format = format.replace(/([yMdhmsqS])+/g, function(minus, tag) {
      var frag = replacers[tag];
      return void 0 !== frag ? (minus.length > 1 && (frag = "0" + frag, frag = frag.substr(frag.length - 2)), frag) : "y" === tag ? (date.getFullYear() + "").substr(4 - minus.length) : minus;
    });
  }
  /**
   * @param {string} c
   * @return {?}
   */
  function FtransferGMTStringtoBJTime(c) {
    if (null == c || (void 0 == c || "" == c)) {
      return null;
    }
    /** @type {Date} */
    var relative_to = new Date(c.replace(/-/g, "/"));
    if ("Invalid Date" == relative_to) {
      return null;
    }
    /** @type {number} */
    var n = 8;
    /** @type {number} */
    var year = relative_to.getTime() + 6E4 * relative_to.getTimezoneOffset() + 36E5 * n;
    return formatDate(new Date(year), "yyyy-MM-dd hh:mm:ss");
  }
  /**
   * @param {?} last
   * @return {?}
   */
  function F_stringToDate(last) {
    if (last) {
      var time = last.toString();
      return time = time.replace(/-/g, "/"), new Date(Date.parse(time));
    }
    return null;
  }
  /**
   * @param {number} value
   * @return {?}
   */
  function FgetDayBeginStr(value) {
    /** @type {Date} */
    var today = new Date(parseInt(value));
    return formatDate(today, "yyyy-MM-dd") + " 00:00:00";
  }
  /**
   * @param {?} object
   * @return {?}
   */
  function FgetDayBegin(object) {
    return F_stringToDate(FgetDayBeginStr(object));
  }
  /**
   * @param {number} value
   * @param {number} expectedNumberOfNonCommentArgs
   * @return {?}
   */
  function FgetOffsetDayBeginStr(value, expectedNumberOfNonCommentArgs) {
    /** @type {Date} */
    var start = new Date(parseInt(value));
    return start.setDate(start.getDate() + expectedNumberOfNonCommentArgs), formatDate(start, "yyyy-MM-dd") + " 00:00:00";
  }
  /**
   * @param {?} date
   * @param {number} exdays
   * @return {?}
   */
  function FgetOffsetDayBeginDate(date, exdays) {
    /** @type {Date} */
    var exdate = new Date(parseInt(date));
    return exdate.setDate(exdate.getDate() + exdays), exdate;
  }
  /**
   * @param {number} isXML
   * @param {number} expectedNumberOfNonCommentArgs
   * @return {?}
   */
  function FgetOffsetDayBegin(isXML, expectedNumberOfNonCommentArgs) {
    return F_stringToDate(FgetOffsetDayBeginStr(isXML, expectedNumberOfNonCommentArgs));
  }
  /**
   * @return {?}
   */
  function FgetTimeStamp() {
    return(new Date).valueOf();
  }
  /**
   * @param {number} mayParseLabeledStatementInstead
   * @param {string} key
   * @param {boolean} recurring
   * @param {?} data
   * @return {?}
   */
  function FtreeForCategory(mayParseLabeledStatementInstead, key, recurring, data) {
    var p;
    var element = {
      id : mayParseLabeledStatementInstead,
      name : key,
      isLeaf : recurring,
      children : []
    };
    /** @type {number} */
    var j = 0;
    for (;p = data[j++];) {
      if (p.pid == mayParseLabeledStatementInstead) {
        element.children.push(FtreeForCategory(p.id, p.name, 0 == p.pid ? false : true, data));
      }
    }
    return element;
  }
  /**
   * @param {?} data
   * @param {string} fileName
   * @return {?}
   */
  function FgetCategoryChildIds(data, fileName) {
    /** @type {string} */
    var path = fileName;
    if (void 0 != fileName && "" != fileName) {
      if (void 0 != data && data.length > 0) {
        /** @type {number} */
        var i = 0;
        for (;i < data.length;i++) {
          if (data[i].pid == fileName) {
            /** @type {string} */
            path = path + "," + FgetCategoryChildIds(data, data[i].id);
          }
        }
        return path;
      }
      return fileName;
    }
    return "";
  }
  /**
   * @param {?} a
   * @param {string} field
   * @param {?} expected
   * @return {?}
   */
  function FremoveByKey(a, field, expected) {
    if (angular.isArray(a)) {
      /** @type {number} */
      var i = 0;
      for (;i < a.length;i++) {
        if (angular.equals(a[i][field], expected)) {
          return void a.splice(i, 1);
        }
      }
    }
  }
  /**
   * @param {string} ch
   * @return {?}
   */
  function FgetBytesLength(ch) {
    var b;
    var matched;
    /** @type {Array} */
    var l = [];
    /** @type {number} */
    var i = 0;
    for (;i < ch.length;i++) {
      b = ch.charCodeAt(i);
      /** @type {Array} */
      matched = [];
      do {
        matched.push(255 & b);
        b >>= 8;
      } while (b);
      /** @type {Array} */
      l = l.concat(matched.reverse());
    }
    return l.length;
  }
  /**
   * @param {?} deepDataAndEvents
   * @param {boolean} dataAndEvents
   * @return {?}
   */
  function formatDouble(deepDataAndEvents, dataAndEvents) {
    /** @type {RegExp} */
    var r20 = /([0-9]+\.[0-9]{2})[0-9]*/;
    return deepDataAndEvents ? Math.abs(parseFloat(("" + parseFloat(deepDataAndEvents)).replace(r20, "$1"))) : dataAndEvents || 0 === dataAndEvents ? dataAndEvents : 0;
  }
  /**
   * @param {?} value
   * @param {string} c
   * @return {?}
   */
  function FisValidCellPhoneNo(value, c) {
    var rchecked;
    return rchecked = "" == c || void 0 == c ? /^1[34578]\d{9}$/ : /^0?[0-9]{8,10}$/, rchecked.test(value);
  }
  /**
   * @param {boolean} val
   * @param {number} dataAndEvents
   * @return {?}
   */
  function FgetPositiveInt(val, dataAndEvents) {
    /** @type {RegExp} */
    var r20 = /([0-9]+\.[0-9]{0})[0-9]*/;
    return val ? Math.abs(parseFloat(("" + parseFloat(val)).replace(r20, "$1"))) : dataAndEvents || "" === dataAndEvents ? dataAndEvents : 0;
  }
  /**
   * @param {Function} input
   * @return {undefined}
   */
  function FgetUrlParam(input) {
    var unlock;
    var data;
    /** @type {Function} */
    var selector = input;
    var dotPos = selector.indexOf("?");
    selector = selector.substr(dotPos + 1);
    var matches = selector.split("&");
    /** @type {number} */
    var i = 0;
    for (;i < matches.length;i++) {
      dotPos = matches[i].indexOf("=");
      if (dotPos > 0) {
        unlock = matches[i].substring(0, dotPos);
        data = matches[i].substr(dotPos + 1);
        this[unlock] = data;
      }
    }
  }
  /**
   * @param {string} obj
   * @param {number} i
   * @param {?} str
   * @return {?}
   */
  function FpadLeft(obj, i, str) {
    return(Array(i).join(str || "0") + obj).slice(-i);
  }
  /**
   * @param {Object} attributes
   * @param {?} prefix
   * @return {?}
   */
  function FgetArrayParam(attributes, prefix) {
    /** @type {Array} */
    var tagNameArr = [];
    var key;
    for (key in attributes) {
      if (attributes.hasOwnProperty(key)) {
        if (angular.isArray(attributes)) {
          /** @type {string} */
          var k = prefix ? prefix + "[]" : key;
          var val = attributes[key];
        } else {
          /** @type {string} */
          k = prefix ? prefix + "[" + key + "]" : key;
          val = attributes[key];
        }
        tagNameArr.push("object" == typeof val ? FgetArrayParam(val, k) : encodeURIComponent(k) + "=" + encodeURIComponent(val));
      }
    }
    return tagNameArr.join("&");
  }
  /**
   * @param {string} mode
   * @return {?}
   */
  function FgetNextEan13Code(mode) {
    if (!mode) {
      return 0;
    }
    mode = mode.slice(0, mode.length - 1);
    /** @type {string} */
    var str = parseInt(mode) + 1 + "";
    if (str && str.length < 12) {
      do {
        /** @type {string} */
        str = "0" + str;
      } while (str.length < 12);
    }
    /** @type {number} */
    var source = 0;
    /** @type {number} */
    var pos = 0;
    /** @type {number} */
    var i = 0;
    for (;i < str.length;i++) {
      if (i % 2 != 1) {
        source += parseInt(str.slice(i, i + 1));
      } else {
        pos += parseInt(str.slice(i, i + 1));
      }
    }
    /** @type {number} */
    var vcards = (10 - (source + 3 * pos) % 10) % 10;
    return str += vcards;
  }
  /**
   * @return {?}
   */
  function onDeviceReady() {
    return window.cordova && window.cordova.plugins ? device.model + " " + device.platform + " " + device.version : "";
  }
  /**
   * @param {string} deepDataAndEvents
   * @param {string} dataAndEvents
   * @return {undefined}
   */
  function FumengOnEventWithLabel(deepDataAndEvents, dataAndEvents) {
    if (window.cordova) {
      if ("undefined" != typeof MobclickAgent) {
        MobclickAgent.onEventWithLabel(deepDataAndEvents, dataAndEvents);
      }
    }
  }
  /**
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  function FappHotUpdate(dataAndEvents) {
    if (window.cordova) {
      if (window.codePush) {
        window.codePush.sync(function(deepDataAndEvents) {
          switch(deepDataAndEvents) {
            case SyncStatus.UPDATE_INSTALLED:
              if (ionic.Platform.isAndroid()) {
                FshowAlert("增量更新安装完成，重启应用生效", function() {
                  window.codePush.restartApplication();
                }, "提示", "确定");
              } else {
                progress.hide();
                FtoastShow("增量更新安装完成.");
              }
              break;
            case SyncStatus.UP_TO_DATE:
              if (dataAndEvents) {
                FtoastShow("应用已是最新版本.");
              }
              break;
            case SyncStatus.UPDATE_IGNORED:
              break;
            case SyncStatus.ERROR:
              if (ionic.Platform.isAndroid()) {
                window.plugins.ProgressView.hide();
                if (dataAndEvents) {
                  FtoastShow("检查更新过程中出错.");
                }
                console.log("检查更新过程中出错.");
              } else {
                progress.show({
                  text : "检查更新过程中出错."
                });
                progress.hide();
              }
              break;
            case SyncStatus.CHECKING_FOR_UPDATE:
              break;
            case SyncStatus.AWAITING_USER_ACTION:
              console.log("等待用户操作.");
              break;
            case SyncStatus.DOWNLOADING_PACKAGE:
              if (ionic.Platform.isAndroid()) {
                window.plugins.ProgressView.show("下载增量更新", "HORIZONTAL");
              } else {
                progress.show({
                  text : "下载增量更新..."
                });
              }
              break;
            case SyncStatus.INSTALLING_UPDATE:
              if (ionic.Platform.isAndroid()) {
                FtoastShow("安装更新中...");
              } else {
                progress.show({
                  text : "安装更新中..."
                });
              }
            ;
          }
        }, {
          installMode : ionic.Platform.isAndroid() ? InstallMode.ON_NEXT_RESTART : InstallMode.IMMEDIATE,
          updateDialog : {
            updateTitle : "版本更新",
            mandatoryUpdateMessage : "重要更新！",
            mandatoryContinueButtonLabel : "继续",
            optionalUpdateMessage : "发现增量更新，是否立刻下载安装?",
            optionalInstallButtonLabel : "下载安装",
            optionalIgnoreButtonLabel : "忽略",
            appendReleaseDescription : true,
            descriptionPrefix : " 新版本特性: "
          }
        }, function(self) {
          if (ionic.Platform.isAndroid()) {
            window.plugins.ProgressView.setProgress(self.receivedBytes / self.totalBytes, function() {
              if (self.receivedBytes == self.totalBytes) {
                window.plugins.ProgressView.hide();
              }
            });
          } else {
            setTimeout(function() {
              progress.update({
                text : "共" + (self.totalBytes / 1024 / 1024).toFixed(2) + "MB, 已下载" + (self.receivedBytes / 1024 / 1024).toFixed(2) + "MB ..."
              });
            }, 300);
          }
        });
      }
    }
  }
  /**
   * @return {undefined}
   */
  function FappHotUpdateSilent() {
    if (window.cordova) {
      if (window.codePush) {
        window.codePush.sync();
      }
    }
  }
  /**
   * @param {Object} event
   * @return {undefined}
   */
  function FhandleApliPayMsg(event) {
    console.log(event.data);
    if (1 == event.data.statusCode) {
      if (event.data.object) {
        if (!FIsNull(Alipay)) {
          Alipay.Base.pay(event.data.object.payInfo, function(e) {
            if ("9000" == e.resultStatus) {
              FtoastShow("支付成功！");
            } else {
              if ("8000" == e.resultStatus) {
                FtoastShow("支付结果确认中");
              } else {
                if (!("6001" == e.resultStatus)) {
                  FtoastShow("支付失败");
                }
              }
            }
            console.log(e);
            document.getElementById("apliPayiFrame").contentWindow.postMessage({
              statusCode : e.resultStatus,
              content : e.memo,
              actionType : "alipayResult"
            }, "*");
          }, function() {
            FtoastShow("支付过程中出现错误");
            console.log(data);
            document.getElementById("apliPayiFrame").contentWindow.postMessage({
              statusCode : 0,
              content : "支付失败",
              actionType : "alipayResult"
            }, "*");
          });
        }
      }
    }
  }
  /**
   * @param {Object} options
   * @return {undefined}
   */
  function FhandleWxpayMsg(options) {
    console.log(options.data);
    if (1 == options.data.statusCode) {
      if (options.data.object) {
        if (!FIsNull(Wechat)) {
          Wechat.sendPaymentRequest(options.data.object.payInfo, function(fmt) {
            FtoastShow("支付成功！");
            console.log(fmt);
            document.getElementById("apliPayiFrame").contentWindow.postMessage({
              statusCode : 1,
              content : "支付成功",
              actionType : "wxpayResult"
            }, "*");
          }, function(fmt) {
            if ("用户点击取消并返回" != fmt) {
              FtoastShow("支付过程中出现错误:" + fmt);
            }
            console.log(fmt);
            document.getElementById("apliPayiFrame").contentWindow.postMessage({
              statusCode : 0,
              content : fmt,
              actionType : "wxpayResult"
            }, "*");
          });
        }
      }
    }
  }
  /**
   * @param {Object} r
   * @param {?} stream
   * @return {undefined}
   */
  function FhandleApliPayMsgInappBrowser(r, stream) {
    console.log(r);
    if (1 == r.statusCode) {
      if (r.payInfo) {
        if (!FIsNull(Alipay)) {
          Alipay.Base.pay(r.payInfo, function(e) {
            if ("9000" == e.resultStatus) {
              FtoastShow("支付成功！");
            } else {
              if ("8000" == e.resultStatus) {
                FtoastShow("支付结果确认中");
              } else {
                if (!("6001" == e.resultStatus)) {
                  FtoastShow("支付失败");
                }
              }
            }
            console.log(e);
            var obj = {
              statusCode : e.resultStatus,
              content : e.memo,
              actionType : "alipayResult"
            };
            /** @type {string} */
            var code = "appPayCallback(" + JSON.stringify(obj) + ");";
            stream.executeScript({
              code : code
            });
          }, function() {
            FtoastShow("支付过程中出现错误");
            console.log(data);
            var obj = {
              statusCode : 0,
              content : "支付失败",
              actionType : "alipayResult"
            };
            /** @type {string} */
            var code = "appPayCallback(" + JSON.stringify(obj) + ");";
            stream.executeScript({
              code : code
            });
          });
        }
      }
    }
  }
  /**
   * @param {Object} r
   * @param {?} stream
   * @return {undefined}
   */
  function FhandleWxpayMsgInappBrowser(r, stream) {
    console.log(r);
    if (1 == r.statusCode) {
      if (r.payInfo) {
        if (!FIsNull(Wechat)) {
          Wechat.sendPaymentRequest(r.payInfo, function(fmt) {
            FtoastShow("支付成功！");
            console.log(fmt);
            var obj = {
              statusCode : 1,
              content : "支付成功",
              actionType : "wxpayResult"
            };
            /** @type {string} */
            var code = "appPayCallback(" + JSON.stringify(obj) + ");";
            stream.executeScript({
              code : code
            });
          }, function(fmt) {
            if ("用户点击取消并返回" != fmt) {
              FtoastShow("支付过程中出现错误:" + fmt);
            }
            console.log(fmt);
            var obj = {
              statusCode : 1,
              content : fmt,
              actionType : "wxpayResult"
            };
            /** @type {string} */
            var code = "appPayCallback(" + JSON.stringify(obj) + ");";
            stream.executeScript({
              code : code
            });
          });
        }
      }
    }
  }
  var breaker = {};
  return{
    /** @type {function (?, boolean): ?} */
    trim : trim,
    /** @type {function (Object, ?, ?, ?, ?): undefined} */
    each : each,
    /** @type {function ((Object|string), ?, ?): ?} */
    some : some,
    /** @type {function (?, ?): ?} */
    union : union,
    /** @type {function (string): ?} */
    toStr : toStr,
    /** @type {function (?): ?} */
    isNull : FIsNull,
    /** @type {function (Object, string): ?} */
    hasOwn : hasOwn,
    /** @type {function (?): ?} */
    isEmpty : isEmpty,
    /** @type {function (?): ?} */
    isNumber : isNum,
    /** @type {function (?): ?} */
    isArray : isArray,
    /** @type {function (string, string): ?} */
    includes : require,
    /** @type {function (string, string): ?} */
    indexOf : indexOf,
    /** @type {function (?, string): ?} */
    contains : contains,
    /** @type {function (Array, ?, ?): ?} */
    containsValue : add,
    /** @type {function (?, ?): ?} */
    accMul : accMul,
    /** @type {function (number, ?): ?} */
    accAdd : accAdd,
    /** @type {function (?, ?): ?} */
    accSub : log,
    /** @type {function (number, number): ?} */
    accDiv : parseTime,
    /** @type {function (number): ?} */
    random : randomInt,
    /** @type {function (Array, Object): ?} */
    intersect : intersect,
    /** @type {function (?): ?} */
    checkType : checkType,
    /** @type {function (?, ?, string, string): ?} */
    idStringToObjectArray : FidStringToObjectArray,
    /** @type {function (?, string, string): ?} */
    fnCheckGtoreQty : FfnCheckGtoreQty,
    /** @type {function (?, ?): ?} */
    getObjectByObject : FgetObjectByObject,
    getObjectByObjectMultUnit : FgetObjectByObjectMultUnit,
    /** @type {function (Array, string, ?): ?} */
    getObjectList : FgetObjectList,
    /** @type {function (Array, string, string): ?} */
    objectArrayToIdString : FobjectArrayToIdString,
    /** @type {function (string, string, string): undefined} */
    toastShow : FtoastShow,
    /** @type {function (string, Function, string, Object): undefined} */
    showAlert : FshowAlert,
    /** @type {function (string, Function, string, Array): undefined} */
    showConfirm : FshowConfirm,
    /** @type {function (string, Function, string, Array, number): undefined} */
    showPrompt : FshowPrompt,
    /** @type {function (Object, Array): ?} */
    getPropertyObj : FgetPropertyObj,
    /** @type {function (): ?} */
    getWindowSizes : getWindowSize,
    /** @type {function (): undefined} */
    keyboardShow : FkeyboardShow,
    /** @type {function (): undefined} */
    keyboardHide : FkeyboardHide,
    /** @type {function (string, string, boolean): ?} */
    versionCompare : FversionCompare,
    /** @type {function (Date, Date): ?} */
    dateFormat : formatDate,
    /** @type {function (number, ?, number): ?} */
    isInDays : FisInDays,
    /** @type {function (?): ?} */
    getDayBegin : FgetDayBegin,
    /** @type {function (number): ?} */
    getDayBeginStr : FgetDayBeginStr,
    /** @type {function (number, number): ?} */
    getOffsetDayBegin : FgetOffsetDayBegin,
    /** @type {function (number, number): ?} */
    getOffsetDayBeginStr : FgetOffsetDayBeginStr,
    /** @type {function (?, number): ?} */
    getOffsetDayBeginDate : FgetOffsetDayBeginDate,
    /** @type {function (): ?} */
    getTimeStamp : FgetTimeStamp,
    /** @type {function (?): ?} */
    _stringToDate : F_stringToDate,
    /** @type {function (string): ?} */
    transferGMTStringtoBJTime : FtransferGMTStringtoBJTime,
    /** @type {function (number, string, boolean, ?): ?} */
    treeForCategory : FtreeForCategory,
    /** @type {function (?, string): ?} */
    getCategoryChildIds : FgetCategoryChildIds,
    /** @type {function (?, string, ?): ?} */
    removeByKey : FremoveByKey,
    /** @type {function (string): ?} */
    getBytesLength : FgetBytesLength,
    /** @type {function (?, boolean): ?} */
    getValidNum : formatDouble,
    /** @type {function (?, string): ?} */
    isValidCellPhoneNo : FisValidCellPhoneNo,
    /** @type {function (boolean, number): ?} */
    getPositiveInt : FgetPositiveInt,
    /** @type {function (Function): undefined} */
    getUrlParam : FgetUrlParam,
    /** @type {function (string, number, ?): ?} */
    padLeft : FpadLeft,
    /** @type {function (Object, ?): ?} */
    getArrayParam : FgetArrayParam,
    /** @type {function (string): ?} */
    getNextEan13Code : FgetNextEan13Code,
    /** @type {function (): ?} */
    getDeviceInfo : onDeviceReady,
    /** @type {function (string, string): undefined} */
    umengOnEventWithLabel : FumengOnEventWithLabel,
    /** @type {function (boolean): undefined} */
    appHotUpdate : FappHotUpdate,
    /** @type {function (): undefined} */
    appHotUpdateSilent : FappHotUpdateSilent,
    /** @type {function (Object): undefined} */
    handleApliPayMsg : FhandleApliPayMsg,
    /** @type {function (Object): undefined} */
    handleWxpayMsg : FhandleWxpayMsg,
    /** @type {function (Object, ?): undefined} */
    handleApliPayMsgInappBrowser : FhandleApliPayMsgInappBrowser,
    /** @type {function (Object, ?): undefined} */
    handleWxpayMsgInappBrowser : FhandleWxpayMsgInappBrowser
  };
});
