angular.module("router", ["ionic"]).config(["$stateProvider", function($stateProvider) {
  $stateProvider.state("KEY280", {
    cache : false,
    url : "/",
    templateUrl : "html/KEY222.html",
    controller : "TutorialCtrl"
  }).state("register", {
    params : {
      phonePre : null
    },
    cache : false,
    url : "/register",
    templateUrl : "html/KEY164.html",
    controller : "RegisterCtrl"
  }).state("KEY214", {
    cache : false,
    url : "/KEY214",
    templateUrl : "html/KEY141.html",
    controller : "RegisterInfoCtrl"
  }).state("KEY226", {
    cache : false,
    url : "/KEY226",
    templateUrl : "html/PSystemSetup/KEY024.html",
    controller : "FindPasswordCtrl"
  }).state("KEY206", {
    cache : false,
    url : "/KEY206",
    templateUrl : "html/PSystemSetup/KEY206.html",
    controller : "ResetPasswordCtrl"
  }).state("signin", {
    cache : false,
    url : "/KEY295",
    templateUrl : "html/KEY223.html",
    controller : "SignInCtrl"
  }).state("eventmenu", {
    url : "/event",
    "abstract" : true,
    templateUrl : "html/KEY199.html",
    controller : "MenuCtrl"
  }).state("eventmenu.main", {
    params : {
      firstLogin : null,
      isAutoLogin : null
    },
    url : "/main",
    views : {
      menuContent : {
        templateUrl : "html/KEY240.html",
        controller : "MainCtrl"
      }
    }
  }).state("eventmenu.KEY281", {
    cache : false,
    url : "/KEY281",
    views : {
      menuContent : {
        templateUrl : "html/PMainPage/KEY149.html",
        controller : "StoreTabCtrl"
      }
    }
  }).state("eventmenu.KEY286", {
    cache : false,
    url : "/KEY286",
    views : {
      menuContent : {
        templateUrl : "html/PMainPage/KEY148.html",
        controller : "SaleTabCtrl"
      }
    }
  }).state("eventmenu.KEY202", {
    cache : false,
    url : "/KEY202",
    views : {
      menuContent : {
        templateUrl : "html/PMainPage/KEY128.html",
        controller : "StatisticsTabCtrl"
      }
    }
  }).state("eventmenu.KEY294", {
    cache : false,
    url : "/KEY294",
    views : {
      menuContent : {
        templateUrl : "html/PMainPage/KEY162.html",
        controller : "AccountCenterTabCtrl"
      }
    }
  }).state("eventmenu.KEY274", {
    cache : false,
    url : "/KEY274",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY056.html",
        controller : "MyAccountCtrl"
      }
    }
  }).state("eventmenu.KEY161", {
    cache : false,
    url : "/KEY161",
    views : {
      menuContent : {
        templateUrl : "html/KEY161.html",
        controller : "MainUserDefinedCtrl"
      }
    }
  }).state("eventmenu.KEY285", {
    url : "/KEY285",
    views : {
      menuContent : {
        templateUrl : "html/PRetailAndSellBill/KEY052.html",
        controller : "SaleListCtrl"
      }
    }
  }).state("eventmenu.KEY284", {
    params : {
      ordersSn : null,
      goodsSn : null,
      goodsId : null,
      timeStamp : null,
      copyOrder : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PRetailAndSellBill/KEY051.html",
        controller : "SaleEditCtrl"
      }
    }
  }).state("eventmenu.KEY260", {
    url : "/KEY260/:ordersSn",
    views : {
      menuContent : {
        templateUrl : "html/PRetailAndSellBill/KEY020.html",
        controller : "SaleDetailCtrl"
      }
    }
  }).state("eventmenu.saleUploadPicture", {
    url : "/saleUploadPicture/:orderId",
    views : {
      menuContent : {
        templateUrl : "html/PRetailAndSellBill/KEY322.html",
        controller : "UploadPictureCtrl"
      }
    }
  }).state("eventmenu.KEY180", {
    url : "/KEY180",
    views : {
      menuContent : {
        templateUrl : "html/PRetailAndSellBill/KEY052.html",
        controller : "SaleListCtrl"
      }
    }
  }).state("eventmenu.KEY179", {
    params : {
      ordersSn : null,
      goodsSn : null,
      timeStamp : null,
      copyOrder : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PRetailAndSellBill/KEY109.html",
        controller : "SaleReturnEditCtrl"
      }
    }
  }).state("eventmenu.KEY145", {
    url : "/KEY145/:ordersSn",
    views : {
      menuContent : {
        templateUrl : "html/PRetailAndSellBill/KEY020.html",
        controller : "SaleDetailCtrl"
      }
    }
  }).state("eventmenu.KEY258", {
    url : "/KEY258",
    views : {
      menuContent : {
        templateUrl : "html/PRetailAndSellBill/KEY182.html",
        controller : "RetailListCtrl"
      }
    }
  }).state("eventmenu.KEY257", {
    params : {
      goodsSn : null,
      goodsId : null,
      timeStamp : null,
      copyOrder : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PRetailAndSellBill/KEY181.html",
        controller : "RetailEditCtrl"
      }
    }
  }).state("eventmenu.KEY215", {
    url : "/KEY215/:ordersSn",
    views : {
      menuContent : {
        templateUrl : "html/PRetailAndSellBill/KEY215.html",
        controller : "RetailDetailCtrl"
      }
    }
  }).state("eventmenu.KEY112", {
    url : "/KEY112",
    views : {
      menuContent : {
        templateUrl : "html/PLogisticsManage/KEY112.html",
        controller : "LogisticsOrderListCtrl"
      }
    }
  }).state("eventmenu.KEY278", {
    url : "/KEY278",
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY062.html",
        controller : "StoreListCtrl"
      }
    }
  }).state("eventmenu.KEY277", {
    url : "/KEY277/:orderNo",
    params : {
      timeStamp : null,
      goods : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY061.html",
        controller : "StoreEditCtrl"
      }
    }
  }).state("eventmenu.KEY256", {
    url : "/KEY256/:orderNo",
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY028.html",
        controller : "StoreDetailCtrl"
      }
    }
  }).state("eventmenu.KEY248", {
    url : "/KEY248",
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY029.html",
        controller : "StockSearchCtrl"
      }
    }
  }).state("eventmenu.KEY207", {
    params : {
      saleDepot : null,
      category : null,
      bland : null,
      existsNumber : null,
      minNumber : null,
      maxNumber : null,
      searchKey : null
    },
    url : "/KEY207",
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY207.html",
        controller : "StockWarnCtrl"
      }
    }
  }).state("eventmenu.KEY135", {
    params : {
      goods : null
    },
    url : "/KEY135",
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY135.html",
        controller : "StockSearchDetailCtrl"
      }
    }
  }).state("eventmenu.KEY138", {
    url : "/KEY138",
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY138.html",
        controller : "StoreTransferListCtrl"
      }
    }
  }).state("eventmenu.KEY137", {
    url : "/KEY137/:orderNo",
    params : {
      timeStamp : null,
      copyOrder : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY137.html",
        controller : "StoreTransferEditCtrl"
      }
    }
  }).state("eventmenu.KEY096", {
    cache : false,
    url : "/KEY096/:orderNo",
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY096.html",
        controller : "StoreTransferDetailCtrl"
      }
    }
  }).state("eventmenu.KEY177", {
    url : "/KEY177",
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY177.html",
        controller : "StoreHouseListCtrl"
      }
    }
  }).state("eventmenu.KEY176", {
    cache : false,
    url : "/KEY176/:id",
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY176.html",
        controller : "StoreHouseEditCtrl"
      }
    }
  }).state("eventmenu.KEY220", {
    url : "/KEY220",
    views : {
      menuContent : {
        templateUrl : "html/PPurchaseBuyBill/KEY091.html",
        controller : "PurchaseListCtrl"
      }
    }
  }).state("eventmenu.KEY219", {
    params : {
      goodsSn : null,
      purchaseSn : null,
      goodsId : null,
      timeStamp : null,
      copyOrder : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PPurchaseBuyBill/KEY090.html",
        controller : "PurchaseEditCtrl"
      }
    }
  }).state("eventmenu.KEY188", {
    url : "/KEY188/:purchaseSn",
    views : {
      menuContent : {
        templateUrl : "html/PPurchaseBuyBill/KEY046.html",
        controller : "PurchaseDetailCtrl"
      }
    }
  }).state("eventmenu.KEY107", {
    url : "/KEY107",
    views : {
      menuContent : {
        templateUrl : "html/PPurchaseBuyBill/KEY091.html",
        controller : "PurchaseListCtrl"
      }
    }
  }).state("eventmenu.KEY106", {
    params : {
      goodsSn : null,
      purchaseSn : null,
      timeStamp : null,
      copyOrder : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PPurchaseBuyBill/KEY090.html",
        controller : "PurchaseEditCtrl"
      }
    }
  }).state("eventmenu.KEY063", {
    url : "/KEY063/:purchaseSn",
    views : {
      menuContent : {
        templateUrl : "html/PPurchaseBuyBill/KEY046.html",
        controller : "PurchaseDetailCtrl"
      }
    }
  }).state("eventmenu.KEY293", {
    cache : false,
    url : "/KEY293",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY172.html",
        controller : "AccountMainCtrl"
      }
    }
  }).state("eventmenu.KEY196", {
    cache : false,
    url : "/KEY196",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY196.html",
        controller : "AccountDetailCtrl"
      }
    }
  }).state("eventmenu.KEY187", {
    cache : false,
    url : "/KEY187",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY187.html",
        controller : "PasswordModifyCtrl"
      }
    }
  }).state("eventmenu.KEY221", {
    url : "/KEY221",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY025.html",
        controller : "PrintSettingCtrl"
      }
    }
  }).state("eventmenu.KEY200", {
    url : "/KEY200",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY200.html",
        controller : "PersonSettingCtrl"
      }
    }
  }).state("eventmenu.KEY250", {
    cache : false,
    url : "/KEY250",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY032.html",
        controller : "ResetSystemCtrl"
      }
    }
  }).state("eventmenu.companyConfig", {
    cache : false,
    url : "/companyConfig/:pageType",
    params : {
      pageType : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY194.html",
        controller : "CompanyConfigCtrl"
      }
    }
  }).state("eventmenu.KEY243", {
    url : "/KEY243",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY031.html",
        controller : "PubroleListCtrl"
      }
    }
  }).state("eventmenu.KEY242", {
    cache : false,
    url : "/KEY242/:id",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY030.html",
        controller : "PubroleEditCtrl"
      }
    }
  }).state("eventmenu.KEY233", {
    cache : false,
    url : "/KEY233",
    views : {
      menuContent : {
        templateUrl : "html/PShopBaseInfo/KEY233.html",
        controller : "ComStoreCtrl"
      }
    }
  }).state("eventmenu.KEY253", {
    params : {
      storeId : null
    },
    url : "/KEY253",
    views : {
      menuContent : {
        templateUrl : "html/PShopBaseInfo/KEY019.html",
        controller : "UserManListCtrl"
      }
    }
  }).state("eventmenu.KEY252", {
    cache : false,
    params : {
      userId : null
    },
    url : "/KEY252",
    views : {
      menuContent : {
        templateUrl : "html/PShopBaseInfo/KEY018.html",
        controller : "UserManEditCtrl"
      }
    }
  }).state("eventmenu.KEY229", {
    url : "/KEY229",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY022.html",
        controller : "BulletinListCtrl"
      }
    }
  }).state("eventmenu.KEY228", {
    cache : false,
    params : {
      id : null
    },
    url : "/KEY228",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY021.html",
        controller : "BulletinEditCtrl"
      }
    }
  }).state("eventmenu.KEY110", {
    params : {
      typeId : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY110.html",
        controller : "PrintSettingDetailCtrl"
      }
    }
  }).state("eventmenu.KEY002", {
    params : {
      typeId : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY002.html",
        controller : "PrintSettingDetailForExpressCtrl"
      }
    }
  }).state("eventmenu.KEY303", {
    cache : false,
    url : "/KEY303",
    views : {
      menuContent : {
        /**
         * @return {?}
         */
        templateUrl : function() {
          return ionic.Platform.isIOS() ? "html/PSystemSetup/KEY099.html" : "html/PSystemSetup/KEY142.html";
        },
        controller : "AboutCtrl"
      }
    }
  }).state("eventmenu.privacy", {
    url : "/privacy",
    views : {
      menuContent : {
        templateUrl : "html/PrivacyPolicy.html"
      }
    }
  }).state("eventmenu.SignIn", {
    url : "/SignIn",
    views : {
      menuContent : {
        templateUrl : "html/tab-signin.html",
        controller : "signinMapCtrl"
      }
    }
  }).state("eventmenu.SignInQuery", {
    url : "/SignInQuery",
    views : {
      menuContent : {
        templateUrl : "html/SignInQuery.html",
        controller : "signinQueryCtrl"
      }
    }
  }).state("eventmenu.SignInCount", {
    url : "/SignInCount",
    views : {
      menuContent : {
        templateUrl : "html/SignInCount.html",
        controller : "signinCountCtrl"
      }
    }
  }).state("eventmenu.KEY290", {
    cache : false,
    url : "/KEY290",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY098.html",
        controller : "FeedbackCtrl"
      }
    }
  }).state("eventmenu.KEY224", {
    cache : false,
    url : "/KEY224",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY023.html",
        controller : "FeedbackListCtrl"
      }
    }
  }).state("eventmenu.KEY288", {
    url : "/KEY288",
    views : {
      menuContent : {
        templateUrl : "html/PWareBaseInfo/KEY153.html",
        controller : "GoodListCtrl"
      }
    }
  }).state("eventmenu.KEY291", {
    params : {
      id : null,
      barCode : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PWareBaseInfo/KEY152.html",
        controller : "GoodEditCtrl"
      }
    }
  }).state("eventmenu.KEY269", {
    url : "/KEY269",
    params : {
      binding : false
    },
    views : {
      menuContent : {
        templateUrl : "html/PClientBaseInfo/KEY115.html",
        controller : "ClientListCtrl"
      }
    }
  }).state("eventmenu.KEY231", {
    cache : false,
    url : "/KEY231/:id",
    views : {
      menuContent : {
        templateUrl : "html/PClientBaseInfo/KEY070.html",
        controller : "ClientDetailCtrl"
      }
    }
  }).state("eventmenu.KEY268", {
    cache : false,
    url : "/KEY268/:id",
    params : {
      name : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PClientBaseInfo/KEY114.html",
        controller : "ClientEditCtrl"
      }
    }
  }).state("eventmenu.KEY195", {
    url : "/KEY195",
    views : {
      menuContent : {
        templateUrl : "html/PClientBaseInfo/KEY195.html",
        controller : "ClientSettingCtrl"
      }
    }
  }).state("eventmenu.KEY122", {
    url : "/KEY122",
    params : {
      clientId : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PClientBaseInfo/KEY122.html",
        controller : "ClientScoreRecordCtrl"
      }
    }
  }).state("eventmenu.KEY080", {
    url : "/KEY080",
    params : {
      oppositeSideId : null,
      clientName : null,
      clientBanlance : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PClientBaseInfo/KEY080.html",
        controller : "ClientDepositRecordCtrl"
      }
    }
  }).state("eventmenu.KEY209", {
    url : "/KEY209",
    params : {
      binding : false
    },
    views : {
      menuContent : {
        templateUrl : "html/PSupplierBaseInfo/KEY060.html",
        controller : "SupplierListCtrl"
      }
    }
  }).state("eventmenu.KEY175", {
    cache : false,
    url : "/KEY175/:id",
    views : {
      menuContent : {
        templateUrl : "html/PSupplierBaseInfo/KEY175.html",
        controller : "SupplierDetailCtrl"
      }
    }
  }).state("eventmenu.KEY208", {
    cache : false,
    url : "/KEY208/:id",
    params : {
      name : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PSupplierBaseInfo/KEY059.html",
        controller : "SupplierEditCtrl"
      }
    }
  }).state("eventmenu.KEY255", {
    url : "/KEY255",
    views : {
      menuContent : {
        templateUrl : "html/PSupplierBaseInfo/KEY210.html",
        controller : "SupplierDebtCtrl"
      }
    }
  }).state("eventmenu.KEY136", {
    params : {
      createTimeBegin : null,
      createTimeEnd : null,
      oppositeSideId : null,
      supplierName : null,
      supplierBanlance : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PSupplierBaseInfo/KEY102.html",
        controller : "SupplierDebtDetailCtrl"
      }
    }
  }).state("eventmenu.KEY072", {
    params : {
      createTimeBegin : null,
      createTimeEnd : null,
      accountId : null,
      businessItem : null,
      accountName : null,
      businessItemName : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PAccountManage/KEY072.html",
        controller : "AccountFinanceRecordCtrl"
      }
    }
  }).state("eventmenu.KEY118", {
    url : "/KEY118",
    views : {
      menuContent : {
        templateUrl : "html/PAccountManage/KEY118.html",
        controller : "AccountFinanceListCtrl"
      }
    }
  }).state("eventmenu.KEY084", {
    params : {
      item : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PAccountManage/KEY084.html",
        controller : "FinanceRecordDetailCtrl"
      }
    }
  }).state("eventmenu.KEY238", {
    url : "/KEY238",
    views : {
      menuContent : {
        templateUrl : "html/PAccountManage/KEY125.html",
        controller : "AccountListCtrl"
      }
    }
  }).state("eventmenu.KEY307", {
    cache : false,
    url : "/KEY307/:id",
    views : {
      menuContent : {
        templateUrl : "html/PAccountManage/KEY307.html",
        controller : "AccountDetailEditCtrl"
      }
    }
  }).state("eventmenu.KEY239", {
    cache : false,
    url : "/KEY239",
    views : {
      menuContent : {
        templateUrl : "html/PAccountManage/KEY126.html",
        controller : "FinanceMainCtrl"
      }
    }
  }).state("eventmenu.KEY237", {
    cache : false,
    url : "/KEY237/:id",
    views : {
      menuContent : {
        templateUrl : "html/PAccountManage/KEY124.html",
        controller : "AccountEditCtrl"
      }
    }
  }).state("eventmenu.KEY159", {
    url : "/KEY159",
    views : {
      menuContent : {
        templateUrl : "html/PAccountManage/KEY159.html",
        controller : "AccountItemListCtrl"
      }
    }
  }).state("eventmenu.KEY158", {
    cache : false,
    url : "/KEY158/:id",
    views : {
      menuContent : {
        templateUrl : "html/PAccountManage/KEY158.html",
        controller : "AccountItemEditCtrl"
      }
    }
  }).state("eventmenu.KEY160", {
    cache : false,
    url : "/KEY160",
    params : {
      accounts : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PAccountManage/KEY160.html",
        controller : "AccountTransferCtrl"
      }
    }
  }).state("eventmenu.KEY170", {
    cache : false,
    url : "/KEY170",
    views : {
      menuContent : {
        templateUrl : "html/PStatisticalChart/KEY170.html",
        controller : "SaleVolumeChartCtrl"
      }
    }
  }).state("eventmenu.KEY198", {
    url : "/KEY198",
    views : {
      menuContent : {
        templateUrl : "html/PStatisticalChart/KEY198.html",
        controller : "OperateDetailCtrl"
      }
    }
  }).state("eventmenu.KEY035", {
    cache : false,
    url : "/KEY035",
    views : {
      menuContent : {
        templateUrl : "html/PStatisticalChart/KEY035.html",
        controller : "StatisticalChartProfitCtrl"
      }
    }
  }).state("eventmenu.KEY074", {
    cache : false,
    url : "/KEY074",
    views : {
      menuContent : {
        templateUrl : "html/PStatisticalChart/KEY074.html",
        controller : "DynamicSaleRateChartCtrl"
      }
    }
  }).state("eventmenu.KEY139", {
    cache : false,
    url : "/KEY139",
    views : {
      menuContent : {
        templateUrl : "html/PStatisticalChart/KEY139.html",
        controller : "TurnOverRateChartCtrl"
      }
    }
  }).state("eventmenu.help", {
    cache : false,
    url : "/help",
    views : {
      menuContent : {
        templateUrl : "html/PSystemHelp/KEY174.html"
      }
    }
  }).state("eventmenu.KEY225", {
    params : {
      code : null,
      goodsSn : null,
      isFromStore : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PWareBaseInfo/KEY154.html",
        controller : "GoodScanNavCtrl"
      }
    }
  }).state("eventmenu.KEY117", {
    cache : false,
    url : "/KEY191",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY033.html",
        controller : "AccountMessageMainCtrl"
      }
    }
  }).state("eventmenu.KEY191", {
    url : "/KEY191",
    params : {
      msgTypeId : null,
      msgTypeName : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY101.html",
        controller : "AccountMessageCtrl"
      }
    }
  }).state("eventmenu.KEY298", {
    cache : false,
    url : "/KEY297",
    views : {
      menuContent : {
        templateUrl : "html/POrderFormInfo/KEY068.html",
        controller : "TmsMainCtrl"
      }
    }
  }).state("eventmenu.KEY262", {
    cache : false,
    url : "/KEY262",
    views : {
      menuContent : {
        templateUrl : "html/POrderFormInfo/KEY131.html",
        controller : "ShopDetailCtrl"
      }
    }
  }).state("eventmenu.KEY320", {
    url : "/KEY320",
    views : {
      menuContent : {
        templateUrl : "html/POrderFormInfo/KEY320.html",
        controller : "TmsPaymentSetCtrl"
      }
    }
  }).state("eventmenu.KEY321", {
    url : "/KEY321",
    views : {
      menuContent : {
        templateUrl : "html/POrderFormInfo/KEY321.html",
        controller : "TmsShippingSetCtrl"
      }
    }
  }).state("eventmenu.KEY318", {
    url : "/KEY318/:tmsGoodsId",
    views : {
      menuContent : {
        templateUrl : "html/POrderFormInfo/KEY318.html",
        controller : "TmsGoodsEditCtrl"
      }
    }
  }).state("eventmenu.KEY319", {
    url : "/KEY319",
    views : {
      menuContent : {
        templateUrl : "html/POrderFormInfo/KEY319.html",
        controller : "TmsGoodsListCtrl"
      }
    }
  }).state("eventmenu.KEY212", {
    url : "/KEY212",
    views : {
      menuContent : {
        templateUrl : "html/POrderFormInfo/KEY130.html",
        controller : "TmsOrderListCtrl"
      }
    }
  }).state("eventmenu.KEY211", {
    cache : false,
    url : "/KEY211/:ordersSn",
    views : {
      menuContent : {
        templateUrl : "html/POrderFormInfo/KEY129.html",
        controller : "TmsOrderEditCtrl"
      }
    }
  }).state("eventmenu.KEY213", {
    url : "/KEY213",
    views : {
      menuContent : {
        templateUrl : "html/POrderFormInfo/KEY037.html",
        controller : "TmsTradeListCtrl"
      }
    },
    params : {
      isSettled : 0
    }
  }).state("eventmenu.KEY116", {
    cache : false,
    url : "/KEY116",
    params : {
      printType : null,
      isClientExpress : false,
      printObject : null,
      labelSetting : null,
      labelArray : null,
      printTimes : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY116.html",
        controller : "BluetoothPrintListCtrl"
      }
    }
  }).state("eventmenu.KEY178", {
    cache : false,
    url : "/report/KEY178",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PSellStatisReport/KEY065.html",
        controller : "SaleReportListCtrl"
      }
    }
  }).state("eventmenu.KEY144", {
    cache : false,
    params : {
      client : null
    },
    url : "/report/KEY144",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PSellStatisReport/KEY144.html",
        controller : "SaleReportCtrl"
      }
    }
  }).state("eventmenu.KEY171", {
    cache : false,
    url : "/report/KEY171",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PSellStatisReport/KEY171.html",
        controller : "SaleReportCtrl"
      }
    }
  }).state("eventmenu.KEY132", {
    cache : false,
    url : "/report/KEY132",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PSellStatisReport/KEY132.html",
        controller : "SaleReportCtrl"
      }
    }
  }).state("eventmenu.KEY133", {
    cache : false,
    url : "/report/KEY133",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PSellStatisReport/KEY133.html",
        controller : "SaleReportCtrl"
      }
    }
  }).state("eventmenu.KEY105", {
    cache : false,
    url : "/report/KEY105",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PSellStatisReport/KEY105.html",
        controller : "SaleReportCtrl"
      }
    }
  }).state("eventmenu.KEY095", {
    cache : false,
    url : "/report/KEY095",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PSellStatisReport/KEY095.html",
        controller : "SaleReportCtrl"
      }
    }
  }).state("eventmenu.KEY008", {
    cache : false,
    url : "/report/KEY008",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PSellStatisReport/KEY008.html",
        controller : "SaleReportCtrl"
      }
    }
  }).state("eventmenu.KEY001", {
    cache : false,
    url : "/report/KEY001",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PSellStatisReport/KEY001.html",
        controller : "SaleReportCtrl"
      }
    }
  }).state("eventmenu.KEY111", {
    cache : false,
    url : "/report/KEY111",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PBuyStatisReport/KEY081.html",
        controller : "PurchaseReportListCtrl"
      }
    }
  }).state("eventmenu.KEY067", {
    cache : false,
    url : "/report/KEY067",
    params : {
      KEY282 : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PBuyStatisReport/KEY067.html",
        controller : "PurchaseReportCtrl"
      }
    }
  }).state("eventmenu.KEY088", {
    cache : false,
    url : "/report/KEY088",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PBuyStatisReport/KEY088.html",
        controller : "PurchaseReportCtrl"
      }
    }
  }).state("eventmenu.KEY048", {
    cache : false,
    url : "/report/KEY048",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PBuyStatisReport/KEY048.html",
        controller : "PurchaseReportCtrl"
      }
    }
  }).state("eventmenu.KEY047", {
    cache : false,
    url : "/report/KEY047",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PBuyStatisReport/KEY047.html",
        controller : "PurchaseReportCtrl"
      }
    }
  }).state("eventmenu.KEY015", {
    cache : false,
    url : "/report/KEY015",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PBuyStatisReport/KEY015.html",
        controller : "PurchaseReportCtrl"
      }
    }
  }).state("eventmenu.KEY089", {
    cache : false,
    url : "/report/KEY089",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PBuyStatisReport/KEY089.html",
        controller : "PurchaseReportCtrl"
      }
    }
  }).state("eventmenu.KEY108", {
    cache : false,
    url : "/report/KEY108",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/KEY108.html",
        controller : "PurchaseVsSaleListCtrl"
      }
    }
  }).state("eventmenu.KEY265", {
    url : "/KEY265",
    views : {
      menuContent : {
        templateUrl : "html/PClientBaseInfo/KEY113.html",
        controller : "ClientDebtCtrl"
      }
    }
  }).state("eventmenu.KEY151", {
    params : {
      oppositeSideId : null,
      clientName : null,
      clientBanlance : null
    },
    url : "/KEY151",
    views : {
      menuContent : {
        templateUrl : "html/PClientBaseInfo/KEY151.html",
        controller : "ClientDebtDetailCtrl"
      }
    }
  }).state("eventmenu.KEY189", {
    params : {
      goods : null
    },
    url : "/KEY189",
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY189.html",
        controller : "GoodStoreQueryCtrl"
      }
    }
  }).state("eventmenu.KEY165", {
    params : {
      storehouse : null,
      goodsName : null,
      goodsSn : null,
      colorId : null,
      sizeId : null,
      updateTimeBegin : null,
      updateTimeEnd : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PStorageStockBill/KEY165.html",
        controller : "GoodStoreRecordCtrl"
      }
    }
  }).state("eventmenu.KEY168", {
    cache : false,
    params : {
      type : null
    },
    url : "/KEY168",
    views : {
      menuContent : {
        templateUrl : "html/PClientBaseInfo/KEY168.html",
        controller : "PickFromContactCtrl"
      }
    }
  }).state("eventmenu.KEY079", {
    url : "/list",
    views : {
      menuContent : {
        templateUrl : "html/PLogisticsManage/KEY083.html",
        controller : "DeliveryCompanyCtrl"
      }
    }
  }).state("eventmenu.KEY078", {
    cache : false,
    params : {
      id : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PLogisticsManage/KEY082.html",
        controller : "DeliveryCompanyEditCtrl"
      }
    }
  }).state("eventmenu.KEY017", {
    views : {
      menuContent : {
        templateUrl : "html/PLogisticsManage/KEY017.html",
        controller : "PrintLogisticsForClientCtrl"
      }
    }
  }).state("eventmenu.KEY266", {
    views : {
      menuContent : {
        templateUrl : "html/PLogisticsManage/KEY014.html",
        controller : "EorderListCtrl"
      }
    }
  }).state("eventmenu.KEY244", {
    url : "/KEY244",
    views : {
      menuContent : {
        templateUrl : "html/PServiceManage/KEY011.html",
        controller : "PaymentListCtrl"
      }
    }
  }).state("eventmenu.KEY246", {
    cache : false,
    url : "/KEY246",
    views : {
      menuContent : {
        templateUrl : "html/PServiceManage/KEY010.html",
        controller : "MyVaServiceCtrl"
      }
    }
  }).state("eventmenu.KEY167", {
    url : "/KEY167",
    params : {
      serviceType : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PServiceManage/KEY167.html",
        controller : "PayServiceApplyCtrl"
      }
    }
  }).state("eventmenu.KEY254", {
    cache : false,
    url : "/KEY244",
    views : {
      menuContent : {
        templateUrl : "html/PServiceManage/KEY012.html",
        controller : "VoucherListCtrl"
      }
    }
  }).state("eventmenu.KEY261", {
    cache : false,
    url : "/KEY261",
    views : {
      menuContent : {
        templateUrl : "html/PServiceManage/KEY066.html",
        controller : "SmsSettingCtrl"
      }
    }
  }).state("eventmenu.KEY275", {
    url : "/KEY275",
    views : {
      menuContent : {
        templateUrl : "html/PServiceManage/KEY034.html",
        controller : "SmsRecordCtrl"
      }
    }
  }).state("eventmenu.KEY249", {
    url : "/smsTemplateList",
    views : {
      menuContent : {
        templateUrl : "html/PServiceManage/KEY050.html",
        controller : "SmsTemplateCtrl"
      }
    }
  }).state("eventmenu.KEY185", {
    url : "/smsTemplateList",
    views : {
      menuContent : {
        templateUrl : "html/PServiceManage/KEY185.html",
        controller : "SmBatchSendingCtrl"
      }
    }
  }).state("eventmenu.KEY276", {
    url : "/KEY276",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY058.html",
        controller : "RecommendCtrl"
      }
    }
  }).state("eventmenu.KEY055", {
    cache : false,
    url : "/report/transfer/KEY055",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PMoveStatisReport/KEY055.html",
        controller : "TransferReportCtrl"
      }
    }
  }).state("eventmenu.KEY054", {
    cache : false,
    url : "/report/transfer/KEY054",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PMoveStatisReport/KEY054.html",
        controller : "TransferReportCtrl"
      }
    }
  }).state("eventmenu.KEY053", {
    cache : false,
    url : "/report/transfer/KEY053",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PMoveStatisReport/KEY053.html",
        controller : "TransferReportCtrl"
      }
    }
  }).state("eventmenu.KEY007", {
    cache : false,
    url : "/report/transfer/KEY007",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PMoveStatisReport/KEY007.html",
        controller : "TransferReportCtrl"
      }
    }
  }).state("eventmenu.KEY134", {
    cache : false,
    url : "/report/store/KEY134",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PStockStatisReport/KEY134.html",
        controller : "StoreReportCtrl"
      }
    }
  }).state("eventmenu.KEY027", {
    cache : false,
    url : "/report/store/KEY027",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PStockStatisReport/KEY027.html",
        controller : "StoreReportCtrl"
      }
    }
  }).state("eventmenu.KEY103", {
    cache : false,
    url : "/report/store/KEY103",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PStockStatisReport/KEY103.html",
        controller : "StoreReportCtrl"
      }
    }
  }).state("eventmenu.KEY026", {
    cache : false,
    url : "/report/store/KEY026",
    views : {
      menuContent : {
        templateUrl : "html/PStatistReport/PStockStatisReport/KEY026.html",
        controller : "StoreReportCtrl"
      }
    }
  }).state("eventmenu.KEY218", {
    url : "/KEY218",
    params : {
      ordersSn : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PWareBaseInfo/KEY016.html",
        controller : "PrintBarCodeCtrl"
      }
    }
  }).state("eventmenu.KEY156", {
    url : "/KEY156",
    views : {
      menuContent : {
        templateUrl : "html/PWareBaseInfo/KEY156.html",
        controller : "GenerateBarCodeCtrl"
      }
    }
  }).state("eventmenu.KEY205", {
    url : "/KEY205",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY205.html",
        controller : "QRCodeSettingCtrl"
      }
    }
  }).state("eventmenu.KEY169", {
    url : "/KEY169",
    views : {
      menuContent : {
        templateUrl : "html/PPassengerVolume/KEY087.html",
        controller : "PVMainCtrl"
      }
    }
  }).state("eventmenu.KEY301", {
    url : "/KEY301",
    views : {
      menuContent : {
        templateUrl : "html/PPassengerVolume/KEY086.html",
        controller : "PVListCtrl"
      }
    }
  }).state("eventmenu.KEY300", {
    cache : false,
    url : "/KEY300",
    params : {
      item : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PPassengerVolume/KEY085.html",
        controller : "PVEditCtrl"
      }
    }
  }).state("eventmenu.KEY283", {
    cache : false,
    url : "/KEY283",
    params : {
      shopName : null,
      imei : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PPassengerVolume/KEY045.html",
        controller : "PVRecordCtrl"
      }
    }
  }).state("eventmenu.KEY299", {
    url : "/KEY299",
    views : {
      menuContent : {
        templateUrl : "html/PBluetoothManage/KEY041.html",
        controller : "BluetoothScanerCtrl"
      }
    }
  }).state("eventmenu.KEY296", {
    cache : false,
    url : "/KEY296",
    params : {
      htmlName : null,
      title : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PServiceManage/KEY064.html",
        controller : "VaApplyCtrl"
      }
    }
  }).state("KEY236", {
    cache : false,
    url : "/KEY236",
    params : {
      type : null
    },
    templateUrl : "html/KEY173.html",
    controller : "GestureLockCtrl"
  }).state("gestureUnLock", {
    cache : false,
    url : "/gestureUnLock",
    params : {
      type : null
    },
    templateUrl : "html/KEY173.html",
    controller : "GestureLockCtrl"
  }).state("eventmenu.KEY234", {
    cache : false,
    url : "/KEY234",
    params : {
      title : null,
      currentUrl : null,
      isSharable : null,
      shareImgUrl : null,
      description : null
    },
    views : {
      menuContent : {
        templateUrl : "html/KEY234.html",
        controller : "CommonIFrameCtrl"
      }
    }
  }).state("eventmenu.collection", {
    cache : false,
    url : "/collection",
    views : {
      menuContent : {
        templateUrl : "html/PWithdrawCash/KEY155.html",
        controller : "CollectionCtrl"
      }
    }
  }).state("eventmenu.cash", {
    cache : false,
    url : "/cash",
    views : {
      menuContent : {
        templateUrl : "html/PWithdrawCash/KEY327.html",
        controller : "CashCtrl"
      }
    }
  }).state("eventmenu.cashHistory", {
    url : "/cashHistory",
    views : {
      menuContent : {
        templateUrl : "html/PWithdrawCash/KEY328.html",
        controller : "CashHistoryCtrl"
      }
    }
  }).state("eventmenu.KEY326", {
    url : "/KEY326",
    views : {
      menuContent : {
        templateUrl : "html/PWithdrawCash/KEY326.html",
        controller : "WeChatPublicCtrl"
      }
    }
  }).state("eventmenu.KEY279", {
    cache : false,
    url : "/KEY279",
    views : {
      menuContent : {
        templateUrl : "html/PSystemSetup/KEY057.html",
        controller : "TradeListCtrl"
      }
    }
  }).state("eventmenu.KEY245", {
    cache : false,
    url : "/KEY245",
    views : {
      menuContent : {
        templateUrl : "html/PCooperatePartner/KEY073.html",
        controller : "PartnerMainCtrl"
      }
    }
  }).state("eventmenu.KEY201", {
    cache : false,
    url : "/KEY201",
    views : {
      menuContent : {
        templateUrl : "html/PCooperatePartner/KEY038.html",
        controller : "PartnerClientCtrl"
      }
    }
  }).state("eventmenu.KEY166", {
    cache : false,
    url : "/KEY166",
    views : {
      menuContent : {
        templateUrl : "html/PCooperatePartner/KEY013.html",
        controller : "PartnerSupplierCtrl"
      }
    }
  }).state("eventmenu.KEY071", {
    cache : false,
    url : "/KEY071",
    views : {
      menuContent : {
        templateUrl : "html/PCooperatePartner/KEY197.html",
        controller : "BindingPartnerClientCtrl"
      }
    }
  }).state("eventmenu.KEY235", {
    cache : false,
    url : "/KEY235",
    params : {
      clientId : null,
      clientName : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PCooperatePartner/KEY005.html",
        controller : "ClientStoreCtrl"
      }
    }
  }).state("eventmenu.KEY123", {
    cache : false,
    url : "/KEY123",
    params : {
      clientId : null,
      goodsId : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PCooperatePartner/KEY123.html",
        controller : "ClientStoreDetailCtrl"
      }
    }
  }).state("eventmenu.KEY044", {
    cache : false,
    url : "/KEY044",
    params : {
      supplierId : null,
      supplierName : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PCooperatePartner/KEY175.html",
        controller : "PartnerSupplierDetailCtrl"
      }
    }
  }).state("eventmenu.businessCommunityMain", {
    url : "/businessCommunityMain",
    views : {
      menuContent : {
        templateUrl : "html/PCommunitySharing/KEY305.html",
        controller : "BusinessCommunityMainCtrl"
      }
    }
  }).state("eventmenu.KEY306", {
    url : "/KEY306",
    params : {
      item : null
    },
    views : {
      menuContent : {
        templateUrl : "html/PCommunitySharing/KEY306.html",
        controller : "InformationDetailCtrl"
      }
    }
  }).state("eventmenu.KEY314", {
    url : "/KEY314",
    views : {
      menuContent : {
        templateUrl : "html/POrderFormInfo/KEY314.html",
        controller : "MemberListCtrl"
      }
    }
  }).state("eventmenu.KEY313", {
    url : "/KEY313",
    params : {
      id : null,
      name : null
    },
    views : {
      menuContent : {
        templateUrl : "html/POrderFormInfo/KEY313.html",
        controller : "MemberEditCtrl"
      }
    }
  }).state("eventmenu.ecommerce", {
    cache : false,
    url : "/KEY309",
    views : {
      menuContent : {
        templateUrl : "html/TaoBaoConnect/KEY309.html",
        controller : "EcommerceCtrl"
      }
    }
  }).state("eventmenu.ecDownload", {
    cache : false,
    url : "/KEY308",
    views : {
      menuContent : {
        templateUrl : "html/TaoBaoConnect/KEY308.html",
        controller : "EcDownloadCtrl"
      }
    }
  }).state("eventmenu.KEY311", {
    cache : false,
    url : "/KEY311",
    views : {
      menuContent : {
        templateUrl : "html/TaoBaoConnect/KEY311.html",
        controller : "EshopListCtrl"
      }
    }
  }).state("eventmenu.eshopInfo", {
    cache : false,
    url : "/KEY310/:id",
    views : {
      menuContent : {
        templateUrl : "html/TaoBaoConnect/KEY310.html",
        controller : "EshopDetailCtrl"
      }
    }
  }).state("eventmenu.taoBaoOrderList", {
    url : "/KEY272",
    views : {
      menuContent : {
        templateUrl : "html/TaoBaoConnect/KEY272.html",
        controller : "EshopOrderCtrl"
      }
    }
  }).state("eventmenu.eshopOrderEdit", {
    cache : false,
    params : {
      orderId : null
    },
    url : "/eshopOrderEdit/:id",
    views : {
      menuContent : {
        templateUrl : "html/TaoBaoConnect/KEY273.html",
        controller : "EshopOrderEditCtrl"
      }
    }
  });
}]);
