var registerPhone = "";
angular.module("starter", ["ionic", "router", "services", "filters", "directives", "saleController", "storeController", "purchaseController", "serviceController", "businessCommunityController", "accountController", "goodController", "clientController", "supplierController", "statisticalChartCtrl", "retailController", "deliveryController", "passengerVolumeCtrl", "bluetoothController", "financeController", "goodScanController", "tmsController", "reportController", "collectionController", "partnerController",
"tools", "angular-md5", "menu", "ngCordova", "angular.filter", "angular-virtual-keyboard", "ecommerceController", "ion-digit-keyboard", "signinController"]).run(["$rootScope", "$ionicPlatform", "$state", "$window", "Tools", "NameConstant", "AuthorityConstant", "psisServices", "ServerConfig", "$ionicHistory", "$timeout", "$ionicPopup", "$cordovaSplashscreen", "commonDataInterface", "lbSpinnerDialog", "VaApplyItem", "BusinessConstant", "wechatShare", "qqShare",
	function(oRootScope, oIonicPlatform, oState, oWindow, oTools, oNameConstant, oAuthorityConstant, oPsisServices, oServerConfig, oIonicHistory, oTimeout, oIonicPopup, oCordovaSplashscreen, oCommonDataInterface, oLbSpinnerDialog, oVaApplyItem, oBusinessConstant, oWechatShare, oQQShare) {
  /**
   * @param {string} res
   * @param {string} key
   * @param {boolean} body
   * @param {string} callback
   * @return {undefined}
   */
  function handler(res, key, body, callback) {
    if (res.search("/timeline/") > -1) {
      oWechatShare.shareUrlToTimeline(res.replace("/timeline/", ""), key, body, callback);
    } else {
      if (res.search("/friend/") > -1) {
        oWechatShare.shareUrlToSession(res.replace("/friend/", ""), key, body, callback);
      } else {
        if (res.search("/qq/") > -1) {
          oQQShare.shareUrlToQq(res.replace("/qq/", ""), key, body, callback);
        } else {
          if (res.search("/qz/") > -1) {
            /** @type {Array} */
            var progressValues = [];
            progressValues.push(callback);
            oQQShare.shareUrlToQz(res.replace("/qz/", ""), key, body, progressValues);
          }
        }
      }
    }
  }
  oRootScope.NameConstant = {};
  angular.extend(oRootScope.NameConstant, oNameConstant);
  oRootScope.AuthorityConstant = {};
  angular.extend(oRootScope.AuthorityConstant, oAuthorityConstant);
  /** @type {boolean} */
  oRootScope.firstTimeEnterMain = true;
  oRootScope.featureObj = {
    vaService : {
      versionCode : 0,
      feature : false
    },
    KEY276 : {
      versionCode : 0,
      feature : false
    },
    versionUpdate : {
      versionCode : 0,
      feature : false
    },
    leftMenu : false,
    tabBadgeForBasic : 0
  };
  /** @type {boolean} */
  oRootScope.isExceptionForAppStore = false;
  /** @type {string} */
  oRootScope.currencySymbol = " ";
  oRootScope.bluethoothScaner = void 0;
  /** @type {number} */
  oRootScope.limitNum = 500;
  oRootScope.serverConfigValue = oServerConfig;
  oServerConfig.currentServer = oServerConfig.webServer;
  oServerConfig.mgrServer = oServerConfig.currentServer.replace("/is", "/mgr");
  oServerConfig.esServer = oServerConfig.currentServer.replace("/is", "/es");
  /**
   * @return {undefined}
   */
  oRootScope.getUnreadMsgCount = function() {
    oPsisServices.post("/KEY227").success(function(uri) {
      /** @type {string} */
      oRootScope.unreadMsgCount = uri;
      if (window.plugins) {
        if (window.plugins.jPushPlugin) {
          if (oRootScope.platformIsIOS) {
            window.plugins.jPushPlugin.setApplicationIconBadgeNumber(oRootScope.unreadMsgCount);
            window.plugins.jPushPlugin.setBadge(oRootScope.unreadMsgCount);
          }
        }
      }
      /** @type {boolean} */
      oRootScope.featureObj.leftMenu = oRootScope.unreadMsgCount > 0 ? true : oRootScope.featureObj.vaService.feature || (oRootScope.featureObj.KEY276.feature || (oRootScope.featureObj.versionUpdate.feature || oRootScope.unreadMsgCount)) ? true : false;
    });
  };
  /**
   * @return {undefined}
   */
  oRootScope.getUserConfigs = function() {
    oCommonDataInterface.getAllUserConfig().then(function(response) {
      if (1 == response.statusCode) {
        if (response.object) {
          oServerConfig.userConfigData = response.object;
        }
      }
    });
  };
  /**
   * @return {undefined}
   */
  oRootScope.getCompanyConfigs = function() {
    /** @type {number} */
    oServerConfig.companyConfigData.saleNegativeStore = 1;
    oCommonDataInterface.getAllCompanyConfig().then(function(body) {
      if (body.object.company && (oRootScope.mainCompany = body.object.company), body.object.companyConfigList) {
        var opts = oTools.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "customerPoint");
        oServerConfig.companyConfigData.customerPoint = opts && opts.configValue ? opts.configValue : oBusinessConstant.CUSTOMERPOINT.OFF;
        var data = oTools.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "saleNegativeStore");
        oServerConfig.companyConfigData.saleNegativeStore = data && data.configValue ? data.configValue : 1;
        var config = oTools.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "currencySymbol");
        if (config && config.configValue) {
          oRootScope.currencySymbol = config.configValue;
          oServerConfig.currencySymbol = config.configValue;
        } else {
          /** @type {string} */
          oRootScope.currencySymbol = "￥";
          /** @type {string} */
          oServerConfig.currencySymbol = "￥";
        }
        var warnNumberTop = oTools.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "warnNumberTop");
        if (warnNumberTop) {
          if (warnNumberTop.configValue) {
            oServerConfig.companyConfigData.warnNumberTop = warnNumberTop.configValue;
          }
        }
        var warnNumberLow = oTools.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "warnNumberLow");
        if (warnNumberLow) {
          if (warnNumberLow.configValue) {
            oServerConfig.companyConfigData.warnNumberLow = warnNumberLow.configValue;
          }
        }
        var postData = oTools.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "goodsSngennerator");
        var API = {
          enable : 2
        };
        if (postData) {
          if (postData.configValue) {
            /** @type {*} */
            API = JSON.parse(postData.configValue);
          }
        }
        /** @type {boolean} */
        oServerConfig.companyConfigData.goodsSngenneratorOn = 1 == API.enable;
      }
    });
  };
  /**
   * @return {undefined}
   */
  oRootScope.getCommonConfigs = function() {
    oCommonDataInterface.getCommonConfigs().then(function(linewidth) {
      oRootScope.commonConfig = linewidth ? linewidth : {};
      oServerConfig.commonConfig = linewidth ? linewidth : {};
      if (linewidth.limitNum) {
        oRootScope.limitNum = linewidth.limitNum;
      }
    });
  };
  /**
   * @return {undefined}
   */
  oRootScope.getPayConfigs = function() {
    oCommonDataInterface.getPayConfigs().then(function(res) {
      if (1 == res.statusCode) {
        oRootScope.alipayAccountType = res.object.alipayAccountType;
        oRootScope.wxpayAccountType = res.object.wxpayAccountType;
      }
    });
  };
  /**
   * @return {undefined}
   */
  oRootScope.getLogInfo = function() {
    /** @type {string} */
    var android = oRootScope.platformIsAndroid ? "android" : "ios";
    /** @type {string} */
    var sPath = "&userid=" + oRootScope.mainUserConfig.userId + "&cid=" + oRootScope.mainUserConfig.cid + "&client=isapp&agent=" + android + "&topic=activity&log=";
    /** @type {string} */
    oRootScope.logPath = "https://xinba-log.log.aliyuncs.com/logstores/log_store_tracking/track?APIVersion=0.6.0" + sPath;
  };
  /**
   * @param {string} sUrl
   * @param {number} dataAndEvents
   * @return {undefined}
   */
  oRootScope.openLink = function(sUrl, dataAndEvents) {
    if (sUrl) {
      if (window.cordova) {
        if ("undefined" != typeof MobclickAgent) {
          MobclickAgent.onEventWithParameters("openLink", {
            link : sUrl
          });
        }
      }
      /** @type {string} */
      var android = oRootScope.platformIsAndroid ? "android" : "ios";
      /** @type {string} */
      var file = "&userid=" + oRootScope.mainUserConfig.userId + "&cid=" + oRootScope.mainUserConfig.cid + "&client=isapp&agent=" + android + "&topic=openLink&log=";
      /** @type {string} */
      var path = "https://xinba-log.log.aliyuncs.com/logstores/log_store_tracking/track?APIVersion=0.6.0" + file;
      if ($.get(path + sUrl), dataAndEvents) {
        var ref;
        /** @type {(Window|null)} */
        ref = ionic.Platform.isAndroid() ? window.open(sUrl, "_blank", "location=yes,zoom=no,toolbarposition=top") : window.open(sUrl, "_blank", "location=no,zoom=no,toolbarposition=top,transitionstyle=crossdissolve,presentationstyle=pagesheet,closebuttoncaption=关闭");
        ref.addEventListener("loadstart", function(request) {
          var requestUrl = request.url;
          if (requestUrl && 0 == requestUrl.indexOf("StarAppData://")) {
            if ("StarAppData://StarAppIM" == requestUrl) {
              oRootScope.openServicIM();
            } else {
              if (0 == requestUrl.indexOf("StarAppData://StarAppShare")) {
                var e = requestUrl.replace("StarAppData://StarAppShare", "");
                var holder = new oTools.getUrlParam(e);
                var camelKey = holder.shareTitle ? decodeURI(holder.shareTitle) : oServerConfig.commonConfig.StarAppShare.shareTitle;
                var json = holder.shareDesc ? decodeURI(holder.shareDesc) : oServerConfig.commonConfig.StarAppShare.shareDesc;
                var restoreScript = holder.shareImgUrl ? decodeURIComponent(holder.shareImgUrl) : oServerConfig.commonConfig.StarAppShare.shareImgUrl;
                handler(e, camelKey, json, restoreScript);
              } else {
                if (0 == requestUrl.indexOf("StarAppData://openPay")) {
                  var res = requestUrl.replace("StarAppData://openPay", "");
                  var r = new oTools.getUrlParam(res);
                  /** @type {string} */
                  var actionType = r.actionType ? decodeURI(r.actionType) : "openWxpay";
                  /** @type {(string|{})} */
                  var statusCode = r.statusCode ? decodeURI(r.statusCode) : {};
                  /** @type {(string|{})} */
                  var cellData = r.payInfo ? decodeURIComponent(r.payInfo) : {};
                  if ("openAlipay" == actionType) {
                    var record = {
                      actionType : actionType,
                      payInfo : cellData,
                      statusCode : statusCode
                    };
                    oTools.handleApliPayMsgInappBrowser(record, ref);
                  } else {
                    record = {
                      actionType : actionType,
                      payInfo : JSON.parse(cellData),
                      statusCode : statusCode
                    };
                    oTools.handleWxpayMsgInappBrowser(record, ref);
                  }
                } else {
                  ref.close();
                  oState.go(requestUrl.replace("StarAppData://", ""));
                }
              }
            }
          }
        });
      } else {
        window.open(sUrl, "_system");
      }
    }
  };
  /**
   * @param {Object} response
   * @return {undefined}
   */
  oRootScope.afterLogin = function(response) {
    /**
     * @param {Object} opts
     * @return {undefined}
     */
    function init(opts) {
      var old = opts.aps.alert;
      if (angular.isObject(opts.aps.alert)) {
        old = opts.aps.alert.title;
        oTools.toastShow("有新的客服消息");
      }
      oTools.showConfirm(old, function(dataAndEvents) {
        if (2 === dataAndEvents) {
          /** @type {string} */
          var path = "eventmenu.KEY191";
          var params = {};
          if (oRootScope.platformIsIOS) {
            if (opts.path) {
              path = opts.path;
            }
            if (opts.param) {
              params.ordersSn = opts.param;
            }
            if (opts.currentUrl) {
              params.currentUrl = opts.currentUrl;
            }
            if (opts.title) {
              params.title = opts.title;
            }
            if (opts.msgTypeId) {
              params.msgTypeId = opts.msgTypeId;
            }
            if (opts.msgTypeName) {
              params.title = opts.msgTypeName;
            }
            oTimeout(function() {
              fn(path, params);
            }, 300);
          }
        }
      }, "有新的通知", ["取消", "查看"]);
    }
    /**
     * @param {Object} config
     * @return {undefined}
     */
    function load(config) {
      /** @type {string} */
      var path = "eventmenu.KEY191";
      var params = {};
      if (oRootScope.platformIsIOS) {
        if (config.path) {
          path = config.path;
        }
        if (config.param) {
          params.ordersSn = config.param;
        }
        if (config.currentUrl) {
          params.currentUrl = config.currentUrl;
        }
        if (config.title) {
          params.title = config.title;
        }
        if (config.msgTypeId) {
          params.msgTypeId = config.msgTypeId;
        }
        if (config.msgTypeName) {
          params.msgTypeName = config.msgTypeName;
        }
      }
      oTimeout(function() {
        try {
          fn(path, params);
        } catch (e) {
          oState.go("eventmenu.KEY191", params);
        }
      }, 300);
    }
    /**
     * @param {string} url
     * @param {?} params
     * @return {undefined}
     */
    function fn(url, params) {
      if (oState.includes("eventmenu.KEY284") || oState.includes("eventmenu.KEY260")) {
        params.timeStamp = oTools.getTimeStamp();
      }
      if ("inappBrowser" == url) {
        oRootScope.openLink(params.currentUrl, 1);
      } else {
        if (!oState.is("eventmenu.main")) {
          if (!oState.is("KEY280")) {
            if (!oState.is("signin")) {
              if (!oState.is("gestureUnLock")) {
                oIonicHistory.viewHistory().currentView = oIonicHistory.viewHistory().backView;
              }
            }
          }
        }
        oState.go(url, params, {
          reload : true
        });
      }
    }
    if (oRootScope.mainUserConfig = response.object.userConfigVO, oRootScope.mainUserConfig, oRootScope.isRefreshGoodsListForMain = true, oRootScope.getOwnAppIds = function() {
      oPsisServices.post("/KEY103", {}).success(function(selfClosing) {
        /**
         * @param {number} opt_attributes
         * @return {?}
         */
        oRootScope.getAppAccResource = function(opt_attributes) {
          return selfClosing.indexOf(opt_attributes) >= 0;
        };
        /**
         * @param {number} name
         * @return {?}
         */
        oRootScope.getAppAuthority = function(name) {
          /** @type {string} */
          var errStr = "";
          if (2 == name ? errStr = "需开通销货宝才能使用此功能，是否开通销货宝？" : 3 == name ? errStr = "需开通会员才能使用此功能，是否开通会员？" : 4 == name ? errStr = "需开通扫码支付才能使用此功能，是否开通扫码支付？" :
          5 == name && (errStr = "需开通客户积分才能使用此功能，是否开通客户积分"), !(selfClosing.indexOf(name) < 0)) {
            return true;
          }
          if (window.cordova && window.cordova.plugins) {
            oTools.showConfirm(errStr, function(dataAndEvents) {
              if (2 == dataAndEvents) {
                oState.go("eventmenu.KEY234", {
                  title : oVaApplyItem.getVaItem[name].title,
                  currentUrl : oVaApplyItem.getVaItem[name].htmlName
                });
              }
            }, "提示", ["取消", "开通"]);
          } else {
            var promise = oIonicPopup.confirm({
              template : "<div class='tc'>" + errStr + "</div>",
              cancelText : "取消",
              okText : "开通"
            });
            promise.then(function(dataAndEvents) {
              if (dataAndEvents) {
                oState.go("eventmenu.KEY234", {
                  title : oVaApplyItem.getVaItem[name].title,
                  currentUrl : oVaApplyItem.getVaItem[name].htmlName
                });
              }
            });
          }
        };
      });
    }, oRootScope.refreshAccRecource = function() {
      oPsisServices.post("/KEY407").success(function(r) {
        if (1 == r.statusCode) {
          oRootScope.getOwnAppIds();
          oRootScope.userAccResource();
        }
      });
    }, oRootScope.getOwnAppIds(), oRootScope.userAccResource = function() {
      oPsisServices.post("/KEY226").success(function(LimitItems) {
        /**
         * @param {string} ItemIndex
         * @return {?}
         */
        oRootScope.GetOperatorEventLimit = function(ItemIndex) {
          return LimitItems.indexOf(ItemIndex) >= 0;
        };
        /**
         * @param {string} a
         * @param {?} B
         * @param {Object} $stateParams
         * @return {undefined}
         */
        oRootScope.aForAccResource = function(a, B, $stateParams) {
          if (oRootScope.GetOperatorEventLimit(a)) {
            if (void 0 != $stateParams) {
              if ($stateParams.timeStamp >= 0) {
                $stateParams.timeStamp = oTools.getTimeStamp();
              }
            }
            oState.go(B, $stateParams);
          } else {
            if (window.cordova && window.cordova.plugins) {
              oTools.showAlert("", null, "权限不足，请联系贵公司负责人授权", "确定");
            } else {
              oIonicPopup.alert({
                template : "<div class='tc'>权限不足，请联系贵公司负责人授权</div>",
                okText : "确定"
              });
            }
          }
        };
        /**
         * @param {Object} data
         * @return {undefined}
         */
        oRootScope.aForAccResourceMenu = function(data) {
          if (data.authority && !oRootScope.GetOperatorEventLimit(data.authority)) {
            if (window.cordova && window.cordova.plugins) {
              oTools.showAlert("", null, "权限不足，请联系贵公司负责人授权", "确定");
            } else {
              oIonicPopup.alert({
                template : "<div class='tc'>权限不足，请联系贵公司负责人授权</div>",
                okText : "确定"
              });
            }
          } else {
            if (void 0 != data.stateParam) {
              if (data.stateParam.timeStamp >= 0) {
                data.stateParam.timeStamp = oTools.getTimeStamp();
              }
            }
            oState.go(data.state, data.stateParam);
          }
        };
      });
    }, oRootScope.userAccResource(), window.plugins && window.plugins.jPushPlugin) {
      window.plugins.jPushPlugin.init();
      window.plugins.jPushPlugin.setLogOFF();
      oTimeout(function() {
        /**
         * @param {?} bElem
         * @return {undefined}
         */
        var restoreScript = function(bElem) {
          if (bElem) {
            var attributes = {
              registrationId : bElem
            };
            try {
              oPsisServices.postEncode("/KEY444", attributes);
            } catch (fmt) {
              console.error(fmt);
            }
          }
        };
        window.plugins.jPushPlugin.getRegistrationID(restoreScript);
      }, 3E3);
      /** @type {Array} */
      var progressValues = [];
      progressValues.push(oServerConfig.jpushCidPrefix + response.object.userConfigVO.cid);
      window.plugins.jPushPlugin.setTagsWithAlias(progressValues, oServerConfig.jpushIdPrefix + response.object.userConfigVO.userId);
      document.addEventListener("jpush.receiveNotification", init, false);
      document.addEventListener("jpush.openNotification", load, false);
      /**
       * @param {string} sMessage
       * @return {undefined}
       */
      window.plugins.jPushPlugin.openNotificationInAndroidCallback = function(sMessage) {
        var sResult;
        /** @type {string} */
        var sView = "";
        var sParams = {};
        try {
          sResult = sMessage.extras;
        } catch (r) {
          sMessage = sMessage.replace('"{"', '{"').replace('"}"', '"}');
          /** @type {*} */
          var node = JSON.parse(sMessage);
          sResult = node.extras;
        }
        sView = sResult["cn.jpush.android.EXTRA"].path ? sResult["cn.jpush.android.EXTRA"].path : "eventmenu.KEY191";
        if (sResult["cn.jpush.android.EXTRA"].param) {
          sParams.ordersSn = sResult["cn.jpush.android.EXTRA"].param;
        }
        if (sResult["cn.jpush.android.EXTRA"].currentUrl) {
          sParams.currentUrl = sResult["cn.jpush.android.EXTRA"].currentUrl;
        }
        if (sResult["cn.jpush.android.EXTRA"].title) {
          sParams.title = sResult["cn.jpush.android.EXTRA"].title;
        }
        if (sResult["cn.jpush.android.EXTRA"].msgTypeId) {
          sParams.msgTypeId = sResult["cn.jpush.android.EXTRA"].msgTypeId;
        }
        if (sResult["cn.jpush.android.EXTRA"].msgTypeName) {
          sParams.msgTypeName = sResult["cn.jpush.android.EXTRA"].msgTypeName;
        }
        oTimeout(function() {
          try {
            if (window.cordova && window.cordova.plugins) {
              oTools.showConfirm("有新的通知，前往查看？", function(dataAndEvents) {
                if (2 == dataAndEvents) {
                  fn(sView, sParams);
                }
              }, null, ["取消", "确定"]);
            } else {
              var promise = oIonicPopup.confirm({
                template : "<div class='tc'>有新的通知，前往查看？</div>",
                cancelText : "取消",
                okText : "确认"
              });
              promise.then(function(dataAndEvents) {
                if (dataAndEvents) {
                  fn(sView, sParams);
                }
              });
            }
          } catch (o) {
            oState.go("eventmenu.KEY191", sParams);
          }
        }, 300);
      };
    }
    if (window.cordova) {
      if ("undefined" != typeof MobclickAgent) {
        if (oServerConfig.currentServer != oServerConfig.exServer) {
          MobclickAgent.profileSignInWithPUID(oWindow.localStorage.KEY293);
        }
      }
    }
    if (window.plugins) {
      if (window.plugins.bluetoothPrinter) {
        window.plugins.bluetoothPrinter.unbondDeviceslist = angular.noop;
        window.plugins.bluetoothPrinter.bondDeviceslist = angular.noop;
      }
    }
    if (window.plugins) {
      if (window.plugins.FlyStarIM) {
        window.plugins.FlyStarIM.initIM(null, null, oServerConfig.taobaoKey);
      }
    }
    oRootScope.getUnreadMsgCount();
    oRootScope.getUserConfigs();
    oRootScope.getCompanyConfigs();
    oRootScope.getCommonConfigs();
    oRootScope.getPayConfigs();
    oRootScope.getLogInfo();
  };
  /**
   * @param {string} args
   * @return {undefined}
   */
  oRootScope.showMessage = function(args) {
    if (window.cordova && window.cordova.plugins) {
      oTools.showAlert("", null, args, "确定");
    } else {
      oIonicPopup.alert({
        template : "<div class='tc'>" + args + "</div>",
        okText : "确定"
      });
    }
  };
  /**
   * @return {undefined}
   */
  oRootScope.openServicIM = function() {
    var r20 = oServerConfig.currentServer.replace("/is", "/mms") + "/KEY426";
    if (oServerConfig.currentServer === oServerConfig.exServer) {
      r20 = oServerConfig.webServer.replace("/is", "/mms") + "/KEY427";
    }
    oPsisServices.fullPathPostEncode(r20, {}).success(function(res) {
      if (1 == res.statusCode && res.object) {
        oWindow.localStorage.IM_UserID = res.object.userid;
        if (window.plugins) {
          if (window.plugins.FlyStarIM) {
            console.log("准备打开IM");
            oLbSpinnerDialog.show();
            window.plugins.FlyStarIM.openServiceIM(function(fmt) {
              console.log(fmt);
              oLbSpinnerDialog.hide();
            }, null, oServerConfig.taobaoKey, res.object.userid, res.object.password, "辛巴坐席");
          }
        }
      } else {
        oTools.toastShow(res.content);
      }
    });
  };
  /**
   * @return {undefined}
   */
  oRootScope.handleAppUrl = function() {
    var url = sessionStorage.getItem("OPENINAPPURL");
    if (url && (url.length > 0 && (url.indexOf(oServerConfig.appScheme) > -1 && (sessionStorage.setItem("OPENINAPPURL", ""), url = url.replace(oServerConfig.appScheme + "://", ""), url.length > 0)))) {
      /** @type {string} */
      var CACHE_BUST_FLAG = "iniframe/";
      /** @type {string} */
      var query = "inappbrowser/";
      if (url.indexOf(CACHE_BUST_FLAG) > -1) {
        url = url.replace(CACHE_BUST_FLAG, "");
        oState.go("eventmenu.KEY234", {
          title : "",
          currentUrl : url
        });
      } else {
        if (url.indexOf(query) > -1) {
          url = url.replace(query, "");
          oRootScope.openLink(url, 1);
        } else {
          oState.go(url);
        }
      }
    }
  };
  oIonicPlatform.ready(function() {
    /**
     * @return {undefined}
     */
    function init() {
      oLbSpinnerDialog.show(true);
      /** @type {number} */
      var timeStampToLock = Math.round(oTools.getTimeStamp() / 1E3);
      if (!oState.is("signin") && ("true" == window.localStorage.isEnableGesturePwd && (window.localStorage.timeStampToLock && timeStampToLock - window.localStorage.timeStampToLock >= 60))) {
        oLbSpinnerDialog.hide();
        oState.go("gestureUnLock");
      } else {
        oLbSpinnerDialog.hide();
        oRootScope.handleAppUrl();
      }
    }
    /**
     * @return {undefined}
     */
    function completed() {
      /** @type {number} */
      window.localStorage.timeStampToLock = Math.round(oTools.getTimeStamp() / 1E3);
    }
    /** @type {boolean} */
    ionic.Platform.isFullScreen = true;
    oRootScope.platformIsIOS = ionic.Platform.isIOS();
    oRootScope.platformIsAndroid = ionic.Platform.isAndroid();
    oRootScope.platformIsPad = ionic.Platform.isIPad() || window.innerWidth >= 768;
    if (ionic.Platform.isAndroid()) {
      /** @type {string} */
      oServerConfig.versionServer = "http://app.xinbafar.com.cn:8080/business/cdn/res/business/download/is/androidVersion.json";
    } else {
      if (ionic.Platform.isIOS()) {
        /** @type {string} */
        oServerConfig.versionServer = "http://app.xinbafar.com.cn:8080/business/cdn/res/business/download/is/iosVersion.json";
      }
    }
    if (window.plugins) {
      if (window.plugins.updateApp) {
        window.plugins.updateApp.checkAndUpdate(oServerConfig.versionServer);
      }
    }
    if (window.cordova) {
      if (window.codePush) {
        if (oServerConfig.isHotUpdate) {
          window.codePush.notifyApplicationReady();
        }
      }
      if (oRootScope.platformIsAndroid) {
        if (window.cordova.plugins) {
          StatusBar.backgroundColorByHexString("#333");
        }
      }
      if (window.cordova.plugins) {
        if (window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
          cordova.plugins.Keyboard.disableScroll(true);
        }
      }
      document.addEventListener("resume", init, false);
      document.addEventListener("pause", completed, false);
      window.plugins.updateApp.getAppVersion(function(ungitVersion) {
        if (oWindow.localStorage.appVersion === ungitVersion && "true" === oWindow.localStorage.didTutorial) {
          var CompanyName = oWindow.localStorage.CompanyName;
          var KEY293 = oWindow.localStorage.KEY293;
          var password = oWindow.localStorage.password;
          if (KEY293 && password) {
            oPsisServices.post("/KEY101?auto=true", {
              CompanyName :CompanyName,
              userName : KEY293,
              password : password
            }).success(function(resp) {
              if (void 0 === resp.statusCode || 0 === resp.statusCode) {
                oState.go("signin");
              } else {
                oRootScope.afterLogin(resp);
                oState.go("eventmenu.main", {
                  isAutoLogin : true
                });
              }
            }).error(function() {
              oState.go("signin");
            }).finally(function() {
              window.setTimeout(function() {
                oCordovaSplashscreen.hide();
              }, 800);
            });
          } else {
            oState.go("signin");
            window.setTimeout(function() {
              oCordovaSplashscreen.hide();
            }, 800);
          }
        } else {
          oState.go("KEY280");
          window.setTimeout(function() {
            oCordovaSplashscreen.hide();
          }, 800);
          /** @type {boolean} */
          oWindow.localStorage.didTutorial = false;
          oWindow.localStorage.appVersion = ungitVersion;
          /** @type {number} */
          oWindow.localStorage.appInstallTime = Math.round(oTools.getTimeStamp() / 1E3);
        }
      });
    } else {
      oState.go("signin");
    }
    /**
     * @return {undefined}
     */
    oRootScope.goBack = function() {
      oIonicHistory.goBack();
    };
    /**
     * @return {undefined}
     */
    oRootScope.viewReplace = function() {
      oIonicHistory.viewHistory().currentView = oIonicHistory.viewHistory().backView;
    };
    /**
     * @param {?} B
     * @param {?} $stateParams
     * @return {undefined}
     */
    oRootScope.goToState = function(B, $stateParams) {
      oState.go(B, $stateParams);
    };
    /**
     * @return {?}
     */
    var click = function() {
      return oState.is("eventmenu.main") || (oState.is("KEY280") || (oState.is("signin") || oState.is("gestureUnLock"))) ? oIonicPopup.confirm({
        title : "<strong>退出应用</strong>",
        template : "<div class='tc'>您确定要退出辛巴手机版吗？</div>",
        okText : "退出",
        cancelText : "取消"
      }).then(function(dataAndEvents) {
        if (dataAndEvents) {
          ionic.Platform.exitApp();
        }
      }) : oRootScope.goBack(), false;
    };
    var rreturn = ionic.debounce(click, 500, true);
    oIonicPlatform.registerBackButtonAction(rreturn, 101);
  });
}]).config(["$httpProvider", "$ionicConfigProvider", "VKI_CONFIG", function($httpProvider, $, err) {
  /** @type {boolean} */
  $httpProvider.defaults.useXDomain = true;
  delete $httpProvider.defaults.headers.common["X-Requested-With"];
  /** @type {string} */
  $httpProvider.defaults.headers.common["qs-referer"] = "appJson";
  /** @type {string} */
  $httpProvider.defaults.headers.common["qs-appversion"] = "2.7.9";
  if (!(window.cordova && window.cordova.plugins)) {
    /** @type {string} */
    $httpProvider.defaults.headers.common["qs-debug"] = "true";
  }
  $.platform.ios.backButton.text("返回");
  $.views.swipeBackEnabled(false);
  $.tabs.position("bottom");
  $.tabs.style("standard");
  if (ionic.Platform.isAndroid()) {
    $.scrolling.jsScrolling(true);
  }
  $.views.transition("none");
  err.layout.FlyStarKeyboard = {
    name : "FlyStarKeyboard",
    keys : [[["Q", "q"], ["W", "w"], ["E", "e"], ["R", "r"], ["T", "t"], ["Y", "y"], ["U", "u"], ["I", "i"], ["O", "o"], ["P", "p"]], [["A", "a"], ["S", "s"], ["D", "d"], ["F", "f"], ["G", "g"], ["H", "h"], ["L", "j"], ["K", "k"], ["L", "l"], ["小写", "Caps"]], [["Z", "z"], ["X", "x"], ["C", "c"], ["V", "v"], ["B", "b"], ["N", "n"], ["M", "m"], ["隐藏", "Close"]]],
    lang : ["pt-BR"]
  };
}]).controller("TutorialCtrl", ["$scope", "$rootScope", "$state", "$window", "psisServices","$ionicPopup","$ionicModal", function(dataAndEvents, $q, app, options, $http,popup,$modal) {
  /**
   * @return {undefined}
   */
  var init = function() {
    /** @type {boolean} */
    options.localStorage.didTutorial = true;
    var CompanyName = options.localStorage.CompanyName;
    var KEY293 = options.localStorage.KEY293;
    var password = options.localStorage.password;

    if (KEY293 && password) {
      $http.post("/KEY101?auto=true", {
        CompanyName :CompanyName,
        userName : KEY293,
        password : password
      }).success(function(response) {
        if (void 0 == response.statusCode || 0 == response.statusCode) {
          app.go("signin");
        } else {
          $q.afterLogin(response);
          app.go("eventmenu.main", {
            isAutoLogin : true
          });
        }
      }).error(function() {
        app.go("signin");
      });
    } else {
      //隐私政策提示框
      if (!CompanyName && !KEY293 && !CompanyName){
        popup.confirm({
          title: '隐私政策',
          template : "<div class='tl'>请你务必审慎阅读、充分理解“隐私政策”各条款，包括但不限于：为了向你提供实现进货管理、销售管理、库存管理、报表等功能，我们需要收集你的设备信息。<br>你可以阅读《隐私政策》了解详细信息。如你同意，请点击“同意”开始接受我们的服务。</div>",
          cancelText : "暂不使用",
          okText : "同意"
        }).then(function(res) {
          if (res) {
            app.go("signin");
          } else {
            ionic.Platform.exitApp();
          }
        });
      }
    }
  };
  /**
   * @return {undefined}
   */
  dataAndEvents.gotoMain = function() {
    init();
  };
}]).controller("RegisterCtrl", ["$scope", "$rootScope", "$state", "psisServices", "$interval", "Tools", "$ionicPopup", "lbSpinnerDialog", "ServerConfig", "$ionicModal", "$stateParams", "BusinessConstant", function($scope, deepDataAndEvents, $state, jasmine, func, self, _, loading, current, $modal, dataAndEvents, data) {
  $scope.validatePhone = {
    smsType : 1
  };
  /** @type {string} */
  $scope.getMessageText = "获取短信验证码";
  /** @type {number} */
  $scope.sesconds = 60;
  /** @type {boolean} */
  $scope.disableMsgBtn = false;
  /** @type {boolean} */
  $scope.showSMSCodeValidate = false;
  current.currentServer = current.webServer;
  var val;
  $scope.internationalCodes = data.INTERNATIONALCODES;
  $scope.obj = {};
  $scope.obj.areaCode = $scope.internationalCodes[0].code;
  if (null != dataAndEvents.phonePre) {
    $scope.obj.areaCode = dataAndEvents.phonePre.areaCode;
    $scope.validatePhone.pre = dataAndEvents.phonePre.pre;
  }
  $modal.fromTemplateUrl("html/PSystemSetup/KEY127.html", function($location) {
    $scope.internationalCodeModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  $scope.openInternationalCodeModal = function() {
    $scope.internationalCodeModal.show();
  };
  $scope.$on("$destroy", function() {
    $scope.internationalCodeModal.remove();
  });
  /**
   * @return {?}
   */
  $scope.cellphoneValidate = function() {
    return self.isValidCellPhoneNo($scope.validatePhone.cellphone, $scope.validatePhone.pre);
  };
  /**
   * @return {?}
   */
  $scope.getSubmitCellphone = function() {
    if ("" == $scope.validatePhone.pre || void 0 == $scope.validatePhone.pre) {
      return $scope.validatePhone.cellphone;
    }
    var frag = $scope.validatePhone.cellphone;
    return "0" == frag.substr(0, 1) && (frag = frag.substr(1)), frag = $scope.validatePhone.pre + frag;
  };
  /**
   * @param {?} event
   * @return {undefined}
   */
  $scope.getValidateSMS = function(event) {
    var str = $scope.getSubmitCellphone();
    /** @type {string} */
    var label = "";
    if (label = 2 === $scope.validatePhone.smsType ? "验证码将拨打至号码:" : "验证码将发送至号码:", window.cordova && window.cordova.plugins) {
      self.showConfirm(label + "\n" + str, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          show();
        }
      }, "确认手机号", ["取消", "好"]);
    } else {
      var promise = _.confirm({
        template : "<div class='tc'>" + label + "<br>" + str + "</div>",
        cancelText : "取消",
        okText : "好"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          show();
        }
      });
    }
    /**
     * @return {undefined}
     */
    var show = function() {
      loading.show();
      if (event.stopPropagation()) {
        event.preventDefault();
      }
      /** @type {string} */
      $scope.validatePhone.verifyCode = "idjisfjw";
      /** @type {boolean} */
      $scope.disableMsgBtn = true;
      /** @type {boolean} */
      $scope.isChangeValidate = false;
      var value = {};
      self.union(value, $scope.validatePhone);
      value.cellphone = $scope.getSubmitCellphone();
      registerPhone = value.cellphone;
      jasmine.postEncode("/KEY253", value).success(function(r) {
        loading.hide();
        if (1 == r.statusCode) {
          /** @type {string} */
          $scope.getMessageText = "60秒后重新获取";
          /** @type {boolean} */
          $scope.showSMSCodeValidate = true;
          val = func(function() {
            if ($scope.sesconds > 0) {
              if (2 === $scope.validatePhone.smsType && $scope.isChangeValidate) {
                /** @type {boolean} */
                $scope.isChangeValidate = false;
                if (angular.isDefined(val)) {
                  func.cancel(val);
                  val = void 0;
                }
                /** @type {number} */
                $scope.sesconds = 60;
                /** @type {boolean} */
                $scope.disableMsgBtn = false;
                /** @type {string} */
                $scope.getMessageText = 2 === $scope.validatePhone.smsType ? "获取语音验证码" : "获取短信验证码";
              } else {
                $scope.sesconds--;
                /** @type {string} */
                $scope.getMessageText = $scope.sesconds + "秒后重新获取";
              }
            } else {
              if (angular.isDefined(val)) {
                func.cancel(val);
                val = void 0;
              }
              /** @type {number} */
              $scope.sesconds = 60;
              /** @type {boolean} */
              $scope.disableMsgBtn = false;
              /** @type {string} */
              $scope.getMessageText = 2 === $scope.validatePhone.smsType ? "获取语音验证码" : "获取短信验证码";
            }
          }, 1E3);
        } else {
          if (3 == r.statusCode) {
            if (window.cordova && window.cordova.plugins) {
              self.showAlert(r.content, function() {
                /** @type {boolean} */
                $scope.disableMsgBtn = false;
              });
            } else {
              _.alert({
                template : "<div class='tc'>" + r.content + "</div>",
                okText : "确定"
              }).then(function() {
                /** @type {boolean} */
                $scope.disableMsgBtn = false;
              });
            }
          }
        }
      }).error(function() {
        loading.hide();
        /** @type {boolean} */
        $scope.disableMsgBtn = false;
      });
    };
  };
  /**
   * @return {undefined}
   */
  $scope.changeToVoiceValidate = function() {
    loading.show();
    /** @type {number} */
    $scope.validatePhone.smsType = 2;
    /** @type {string} */
    $scope.getMessageText = "获取语音验证码";
    /** @type {boolean} */
    $scope.isChangeValidate = true;
    loading.hide();
    self.toastShow("已切换到语音验证码方式");
    if ($scope.validatePhone.pre) {
      if ("" != $scope.validatePhone.pre) {
        /** @type {string} */
        $scope.validatePhone.pre = "";
      }
    }
  };
  /**
   * @return {?}
   */
  $scope.validateInput = function() {
    return!$scope.cellphoneValidate() || $scope.disableMsgBtn;
  };
  /**
   * @return {undefined}
   */
  $scope.beforeGotoSignIn = function() {
    if ($scope.showSMSCodeValidate) {
      if (window.cordova && window.cordova.plugins) {
        self.showConfirm("验证码发送可能略有延迟", function(dataAndEvents) {
          if (1 == dataAndEvents) {
            $scope.gotoSignIn();
          }
        }, "确认退出注册?", ["退出", "继续等待"]);
      } else {
        var promise = _.confirm({
          template : "<div class='tc'>验证码发送可能略有延迟<br>确认退出注册?</div>",
          cancelText : "退出",
          okText : "等待"
        });
        promise.then(function(dataAndEvents) {
          if (!dataAndEvents) {
            $scope.gotoSignIn();
          }
        });
      }
    } else {
      $scope.gotoSignIn();
    }
  };
  /**
   * @return {undefined}
   */
  $scope.gotoSignIn = function() {
    if (window.cordova && (window.cordova.plugins && window.cordova.plugins.Keyboard)) {
      cordova.plugins.Keyboard.close();
      window.setTimeout(function() {
        $scope.goBack();
      }, 500);
    } else {
      $scope.goBack();
    }
  };
  /**
   * @param {?} event
   * @return {undefined}
   */
  $scope.validateSmsCode = function(event) {
    event.stopPropagation();
    loading.show(true);
    jasmine.postEncode("/KEY254", {
      smsCode : self.padLeft($scope.validatePhone.smsCode, 4)
    }).success(function(r) {
      if (1 == r.statusCode) {
        $state.go("KEY214");
      } else {
        if (2 == r.statusCode) {
          self.toastShow("验证码不正确，请重新输入");
        }
      }
    }).finally(function() {
      loading.hide();
    });
  };
  $scope.$on("$ionicView.afterEnter", function() {
    /** @type {boolean} */
    $scope.focusInput = true;
  });
}]).controller("RegisterInfoCtrl", ["$scope", "$rootScope", "$state", "psisServices", "$ionicPopup", "md5", "$window", "lbSpinnerDialog", "$timeout", "Tools", function($scope, dataAndEvents, app, store, _, md5, options, loading, forOwn, self) {
  $scope.userAndCom = {};
  /**
   * @param {Object} event
   * @return {?}
   */
  $scope.gobackAction = function(event) {
    if (event && (event.stopPropagation() && event.preventDefault()), window.cordova && window.cordova.plugins) {
      self.showConfirm("", function(dataAndEvents) {
        if (1 == dataAndEvents) {
          $scope.goBack();
        }
      }, "确定要退出注册并重新开始?", ["退出", "继续注册"]);
    } else {
      var promise = _.confirm({
        template : "<div class='tc'>确认要退出注册?</div>",
        cancelText : "继续注册",
        okText : "退出"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          $scope.goBack();
        }
      });
    }
    return false;
  };
  /**
   * @return {?}
   */
  $scope.save = function() {
    return $scope.userAndCom.password1 !== $scope.userAndCom.password2 ? (window.cordova && window.cordova.plugins ? self.showAlert("", null, "两次填写的密码不一致", "确认") : _.alert({
      template : "<div class='tc'>两次填写的密码不一致</div>",
      okText : "确定"
    }), false) : (loading.show(true), $scope.userAndCom.cellphone = registerPhone, $scope.userAndCom.password = $scope.userAndCom.password1 ? md5.createHash($scope.userAndCom.password1).toUpperCase() : void 0, $scope.userAndCom.password1 = "", $scope.userAndCom.password2 = "", void store.postEncode("/KEY255", $scope.userAndCom).success(function(res) {
      /**
       * @return {undefined}
       */
      function reset() {
        options.localStorage.KEY293 = res.object.cellphone;
        /** @type {string} */
        options.localStorage.password = "";
        if (window.plugins) {
          if (window.plugins.jPushPlugin) {
            forOwn(function() {
              /**
               * @param {?} stats
               * @return {undefined}
               */
              var cb = function(stats) {
                if (stats) {
                  var attributes = {
                    registrationId : stats
                  };
                  try {
                    store.postEncode("/KEY444", attributes);
                  } catch (fmt) {
                    console.error(fmt);
                  }
                }
              };
              window.plugins.jPushPlugin.getRegistrationID(cb);
            }, 5E3);
          }
        }
        app.go("signin");
      }
      if (1 == res.statusCode) {
        if (window.cordova && window.cordova.plugins) {
          self.showAlert("注册成功，请用手机号 " + res.object.cellphone + " 登录", reset);
        } else {
          _.alert({
            template : "<div class='tc'>注册成功，请用注册手机号<span class='fb'>" + res.object.cellphone + "</span>登录</div>",
            okText : "确定"
          }).then(reset);
        }
      } else {
        if (window.cordova && window.cordova.plugins) {
          self.showAlert(data.content);
        } else {
          _.alert({
            template : "<div class='tc'>" + data.content + "</div>",
            okText : "确定"
          });
        }
      }
    }).finally(function() {
      loading.hide();
    }));
  };
}])



  .controller("SignInCtrl", ["$scope", "$rootScope", "$state", "$window", "psisServices", "md5", "lbSpinnerDialog", "$ionicPopup", "Tools", "ServerConfig","$ionicModal", function($scope, panel, app, options, $http, md5, loading, sController, sSelf, current,$modal) {

    $modal.fromTemplateUrl("privacyPolicyModal.html", function($location) {
      /** @type {number} */
      $scope.privacyPolicyModal = $location;
    }, {
      scope : $scope,
      animation : "slide-in-up"
    });

    $scope.openPrivacyPolicyModal = function () {
      $scope.privacyPolicyModal.show();
    };

    $scope.closePrivacyPolicyModal = function () {
      $scope.privacyPolicyModal.hide();
    };

  $scope.userModel = {};
  var sCompanyName = void 0 !== options.localStorage.CompanyName ? options.localStorage.CompanyName : "默认公司";
  var sUserName = void 0 !== options.localStorage.KEY293 ? options.localStorage.KEY293 : "";
  var sPassword = void 0 !== options.localStorage.password ? options.localStorage.password : "";

  $scope.userModel.CompanyName = void 0 !== options.localStorage.CompanyName ? options.localStorage.CompanyName : "默认公司";
  $scope.userModel.userName = void 0 !== options.localStorage.KEY293 ? options.localStorage.KEY293 : "";
  $scope.userModel.password = void 0 !== options.localStorage.password ? options.localStorage.password : "";
  /**
   * @param {?} sUserName
   * @param {?} sPassword
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  var funLoginSuccess = function(sCompanyName, sUserName, sPassword, dataAndEvents) {
    current.currentServer = current.webServer;
    current.mgrServer = current.currentServer.replace("/is", "/mgr");
    current.esServer = current.currentServer.replace("/is", "/es");
    loading.show();
    $http.post("/KEY101?auto=true", {
      CompanyName : sCompanyName,
      userName : sUserName,
      password : sPassword
    }).success(function(response) {
      if (void 0 == response.statusCode || 0 == response.statusCode) {
        if (window.cordova && window.cordova.plugins) {
          sSelf.showAlert("", function() {
            options.localStorage.CompanyName = "";
            /** @type {string} */
            options.localStorage.password = "";
            /** @type {string} */
            $scope.userModel.password = "";
          }, response.content, "确定");
        } else {
          var promise = sController.alert({
            template : "<div class='tc'>" + response.content + "</div>",
            okText : "确定"
          });
          promise.then(function() {
            options.localStorage.CompanyName = "";
            /** @type {string} */
            options.localStorage.password = "";
            /** @type {string} */
            $scope.userModel.password = "";
          });
        }
      } else {
        if (dataAndEvents) {
          options.localStorage.CompanyName = sCompanyName;
          options.localStorage.KEY293 = sUserName;
          options.localStorage.password = sPassword;
        }
        panel.afterLogin(response);
        app.go("eventmenu.main", {
          firstLogin : response.object.firstLogin
        });
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  $scope.login = function() {
    sSelf.keyboardHide();

    var sCompanyName = $scope.userModel.CompanyName;
    var sUserName = $scope.userModel.userName;
    var password = $scope.userModel.password;
    funLoginSuccess(sCompanyName, sUserName, md5.createHash(password.toString()).toUpperCase(), true);
    sSelf.umengOnEventWithLabel("loginPage_loginButton", "登录页登录按钮");
  };
  /**
   * @return {undefined}
   */
  $scope.tiyanLogin = function() {
    current.currentServer = current.exServer;
    current.mgrServer = current.currentServer.replace("/is", "/mgr");
    current.esServer = current.currentServer.replace("/is", "/es");
    loading.show();
    $http.post("/KEY102").success(function(response) {
      sSelf.umengOnEventWithLabel("loginPage_tiyanButton", "登录页体验按钮");
      if (void 0 == response.statusCode || 0 == response.statusCode) {
        if (window.cordova && window.cordova.plugins) {
          sSelf.showAlert("", null, "体验帐号登录失败", "确定");
        } else {
          sController.alert({
            template : "<div class='tc'>体验帐号登录失败</div>",
            okText : "确定"
          });
        }
      } else {
        panel.afterLogin(response);
        app.go("eventmenu.main");
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  $scope.register = function() {
    sSelf.umengOnEventWithLabel("loginPage_registerButton", "登录页注册按钮");
    app.go("register");
  };
  /**
   * @return {undefined}
   */
  $scope.openForgetPwd = function() {
    sSelf.umengOnEventWithLabel("loginPage_forgetPassword", "登录页忘记密码");
    app.go("KEY226");
  };
  if (window.cordova) {
    /** @type {string} */
    $scope.userModel.password = "";
  } else {
    if ("" !== sUserName) {
      if ("" !== sPassword) {
        funLoginSuccess(sCompanyName, sUserName, sPassword);
      }
    }
  }
  $scope.$on("$ionicView.loaded", function() {
  });

  //根据手机号查询公司id
  $scope.autoGetCompanyName = function () {
    if($scope.userModel.userName.length >= 11) {
      $http.post("/initialize/getCompanyName",{
        username : $scope.userModel.userName,
        password : $scope.userModel.password
      }).success(function(result) {
        if (result.statusCode === 1) {
          $scope.userModel.CompanyName = result.object;
        }
      });
    }
  };

}]).controller("MenuCtrl", ["$scope", "$ionicSideMenuDelegate", "$ionicNavBarDelegate", "$window", "$state", "psisServices", "ServerConfig", "showInstructionBackdrop", "Menu", "lruPersistCache", "$templateCache", "commonDataInterface", "Tools", "VaApplyItem", "$ionicLoading", "$ionicSlideBoxDelegate", function(self, dataAndEvents, deepDataAndEvents, w, res, opt_attributes, context, poster, matcherFunction, node, $templateCache, textAlt, $rootScope, keepData, indicator,
ignoreMethodDoesntExist) {

  self.menuList = matcherFunction;

  /**
   * @param {boolean} viewProperty
   * @param {boolean} helper
   * @param {boolean} view
   * @return {?}
   */
  self.listStyle = function(viewProperty, helper, view) {
    return viewProperty ? "lb-this-edit-bg-loading" : helper ? "" : view ? "" : "lb-this-edit-bg-empty";
  };
  /**
   * @return {?}
   */
  self.getAppVersion = function() {
    return w.localStorage.appVersion;
  };
  /**
   * @return {?}
   */
  self.getInnerAppVersion = function() {
    return context.innerAppVersion;
  };
  /**
   * @return {undefined}
   */
  self.signOut = function() {
    var template = $templateCache.get("keyboard.tpl.html");
    if (node.removeAll(), $templateCache.removeAll(), $templateCache.put("keyboard.tpl.html", template), dataAndEvents.$getByHandle("main-handle").isOpenLeft() && dataAndEvents.$getByHandle("main-handle").toggleLeft(), context.currentServer = context.webServer, context.mgrServer = context.currentServer.replace("/is", "/mgr"), context.esServer = context.currentServer.replace("/is", "/es"), w.localStorage.password = "", window.plugins && window.plugins.FlyStarIM) {
      var r20 = w.localStorage.IM_UserID;
      if (r20) {
        console.log("window.plugins.FlyStarIM.logoutIM");
        window.plugins.FlyStarIM.logoutIM(function(fmt) {
          console.log(fmt);
        }, function(fmt) {
          console.log(fmt);
        }, context.taobaoKey, r20);
      }
      /** @type {string} */
      w.localStorage.IM_UserID = "";
    }
    if (window.cordova) {
      if ("undefined" != typeof MobclickAgent) {
        if (context.currentServer != context.exServer) {
          MobclickAgent.profileSignOff();
        }
      }
    }
    res.go("signin");
  };
  /**
   * @param {string} b
   * @return {undefined}
   */
  self.phoneCall = function(b) {
    if (b) {
      /** @type {string} */
      document.location.href = "tel:" + b;
    }
  };
  /**
   * @return {undefined}
   */
  self.toggleLeft = function() {
    dataAndEvents.$getByHandle("main-handle").toggleLeft();
  };
  /**
   * @param {boolean} recurring
   * @return {undefined}
   */
  self.dragMenu = function(recurring) {
    dataAndEvents.$getByHandle("main-handle").canDragContent(recurring);
  };
  /**
   * @param {string} attributes
   * @return {undefined}
   */
  self.setTitle = function(attributes) {
    deepDataAndEvents.$getByHandle("mainMenuBar").title(attributes);
  };
  /**
   * @param {?} shallow
   * @return {undefined}
   */
  self.showBar = function(shallow) {
    deepDataAndEvents.$getByHandle("mainMenuBar").showBar(shallow);
  };
  /**
   * @return {undefined}
   */
  self.closeInstructionBackdrop = function() {
    poster.hide();
  };
  /**
   * @param {string} whitespace
   * @return {?}
   */
  self.getListPictureUrl = function(whitespace) {
    return whitespace ? -1 != whitespace.indexOf("app.xinbafar.com.cn:8080/business") ? whitespace /*带上这个就不能显示+ "@!goodalbum" */: whitespace : "img/detailpic_no.png";
  };
  /**
   * @return {?}
   */
  self.getValidateCodeImgUrl = function() {
    return context.currentServer + "/captchaImage.ac?random=" + $rootScope.getTimeStamp();
  };
  /**
   * @param {Object} path
   * @param {Array} img
   * @param {?} data
   * @return {undefined}
   */
  self.saveImage = function(path, img, data) {
    if (data) {
      data.stopPropagation();
    }
    if (null == path) {
      if (img) {
        if (img.length > 0) {
          path = img[ignoreMethodDoesntExist.$getByHandle("imgShowDelegate").currentIndex()].url;
        }
      }
    }
    if (path) {
      if (window.cordova) {
        if (window.cordova.plugins) {
          indicator.show({
            template : "图片保存中..."
          });
          cordova.plugins.saveImageToAlbum.save(path, function() {
            indicator.show({
              template : "图片已成功保存在相册中",
              duration : 1E3
            });
          }, function(fmt) {
            $rootScope.showAlert("图片保存失败");
            console.error(fmt);
            indicator.hide();
          });
        }
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.goToVipApply = function() {
    self.openLinkInIframe(keepData.getVaItem[3].title, keepData.getVaItem[3].htmlName);
  };
  /**
   * @return {undefined}
   */
  self.goToPaymentList = function() {
    w.localStorage.vaServiceCode = self.featureObj.vaService.versionCode;
    /** @type {boolean} */
    self.featureObj.vaService.feature = false;
    /** @type {boolean} */
    self.featureObj.leftMenu = self.featureObj.vaService.feature || (self.featureObj.KEY276.feature || (self.featureObj.versionUpdate.feature || self.unreadMsgCount)) ? true : false;
    res.go("eventmenu.KEY244");
  };
  /**
   * @return {undefined}
   */
  self.goToRecommend = function() {
    w.localStorage.recommendCode = self.featureObj.KEY276.versionCode;
    /** @type {boolean} */
    self.featureObj.KEY276.feature = false;
    /** @type {boolean} */
    self.featureObj.leftMenu = self.featureObj.vaService.feature || (self.featureObj.KEY276.feature || (self.featureObj.versionUpdate.feature || self.unreadMsgCount)) ? true : false;
    res.go("eventmenu.KEY276");
  };
  /**
   * @return {undefined}
   */
  self.goToVersionUpdate = function() {
    w.localStorage.versionUpdateCode = self.featureObj.versionUpdate.versionCode;
    /** @type {boolean} */
    self.featureObj.versionUpdate.feature = false;
    /** @type {boolean} */
    self.featureObj.leftMenu = self.featureObj.vaService.feature || (self.featureObj.KEY276.feature || (self.featureObj.versionUpdate.feature || self.unreadMsgCount)) ? true : false;
    self.openLink("http://app.xinbafar.com.cn:8080/business/m/versionUpdate.html", true);
  };
  /**
   * @param {?} x
   * @param {string} dataAndEvents
   * @return {undefined}
   */
  self.openLinkInIframe = function(x, dataAndEvents) {
    if (dataAndEvents) {
      res.go("eventmenu.KEY234", {
        title : x,
        currentUrl : dataAndEvents
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.getFeatureModule = function() {
    textAlt.getModuleVersionData().then(function(a) {
      var al = a.vaServiceCode;
      var il = a.recommendCode;
      var aLength = a.versionUpdateCode;
      self.featureObj.vaService.versionCode = al;
      self.featureObj.KEY276.versionCode = il;
      self.featureObj.versionUpdate.versionCode = aLength;
      if (!w.localStorage.vaServiceCode || al > w.localStorage.vaServiceCode) {
        /** @type {boolean} */
        self.featureObj.vaService.feature = true;
        /** @type {boolean} */
        self.featureObj.leftMenu = true;
      }
      if (!w.localStorage.recommendCode || il > w.localStorage.recommendCode) {
        /** @type {boolean} */
        self.featureObj.KEY276.feature = true;
        /** @type {boolean} */
        self.featureObj.leftMenu = true;
      }
      if (!w.localStorage.versionUpdateCode || aLength > w.localStorage.versionUpdateCode) {
        /** @type {boolean} */
        self.featureObj.versionUpdate.feature = true;
        /** @type {boolean} */
        self.featureObj.leftMenu = true;
      }
    });
  };
  /** @type {number} */
  w.localStorage.timeStampToRefresh = Math.round($rootScope.getTimeStamp() / 1E3);
  self.getFeatureModule("loaded");
}]).controller("MainCtrl", ["$scope", "$rootScope", "Menu", "$state", "lbScrollDelegate", "psisServices", "Tools", "$ionicPlatform", "lbSlideData", "$timeout", "$templateCache", "ServerConfig", "$window", "$ionicPopover", "showInstructionBackdrop", "$stateParams", "$q", "$http", "commonDataInterface", "BTScanerService", "$ionicModal","$ionicPopup", function(self, scope, theTitle, context, parent, ret, $scope, ignoreMethodDoesntExist, defer, select, $templateCache, current,
$window, FB, poster, dataAndEvents, $q, $injector, deepDataAndEvents, $document, $modal,popup) {
  /**
   * @return {?}
   */
  function fn() {
    var imageDfd = $q.defer();
    var o = current.currentServer.replace("/is", "").replace("ex.", "www.").replace("web.", "www.");
    return $injector.get(o + "/download/data/instructionData.json?random=" + $scope.getTimeStamp()).success(function(image) {
      imageDfd.resolve(image);
    }).error(function() {
      console.error("从服务器获取新手提示信息异常！");
      imageDfd.reject();
    }), imageDfd.promise;
  }
  var callback = angular.noop;
  /** @type {boolean} */
  var T = false;
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return ret.postEncode("/KEY233", opt_attributes);
  };
  /** @type {number} */
  $window.localStorage.isBLEPrinted = 0;
  dataAndEvents.firstLogin;
  self.search = {
    goodKey : "",
    show : false,
    focused_good : "centered_main"
  };
  scope.mainTipsShowPopover = FB.fromTemplate('<ion-popover-view class="h100"><ion-content class="p15">{{tips.content}}</ion-content></ion-popover-view>', {
    scope : scope
  });
  /**
   * @param {Object} h
   * @param {Object} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  scope.mainTipsShow = function(h, expectedNumberOfNonCommentArgs) {
    if (expectedNumberOfNonCommentArgs) {
      expectedNumberOfNonCommentArgs.stopPropagation();
    }
    scope.tips = {
      content : h
    };
    scope.mainTipsShowPopover.show(expectedNumberOfNonCommentArgs);
  };
  /** @type {boolean} */
  scope.isRefreshGoodsListForMain = false;
  scope.sysConfig = {};
  if (void 0 !== $window.localStorage.allowEditGoodImg) {
    /** @type {boolean} */
    scope.sysConfig.allowEditGoodImg = "true" == $window.localStorage.allowEditGoodImg;
  } else {
    /** @type {boolean} */
    scope.sysConfig.allowEditGoodImg = true;
    /** @type {boolean} */
    $window.localStorage.allowEditGoodImg = true;
  }
  /**
   * @return {undefined}
   */
  self.addGood = function() {
    if (self.isFromScanToAddGoodsTrend = true) {
      context.go("eventmenu.KEY291", {
        barCode : self.search.goodKey
      });
      /** @type {boolean} */
      self.isFromScanToAddGoodsTrend = false;
    } else {
      context.go("eventmenu.KEY291");
    }
  };
  /**
   * @param {?} _xhr
   * @return {undefined}
   */
  self.KEY264 = function(_xhr) {
    context.go("eventmenu.KEY225", {
      code : _xhr.id,
      goodsSn : _xhr.goodsSn
    });
  };
  /**
   * @return {undefined}
   */
  self.scanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(result) {
      if (!result.cancelled) {
        self.$apply(function() {
          /** @type {boolean} */
          T = true;
          self.search.goodKey = result.text;
          /** @type {string} */
          self.search.focused_good = "text-left";
          self.searchGoods();
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      $scope.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @param {string} keepData
   * @return {undefined}
   */
  self.searchGoodsByBarCode = function(keepData) {
    /** @type {string} */
    self.search.goodKey = keepData;
    /** @type {string} */
    self.search.focused_good = "text-left";
    deepDataAndEvents.getGoodsByBarCode(keepData).then(function(dataAndEvents) {
      if (null != dataAndEvents) {
        self.openSearch();
        /** @type {boolean} */
        self.isFromScanToAddGoodsTrend = true;
        /** @type {Array} */
        self.KEY288 = [];
        if (dataAndEvents) {
          /** @type {string} */
          self.KEY288[0] = dataAndEvents;
          /** @type {boolean} */
          self.loadMoreBtn = false;
          self.KEY264(self.KEY288[0]);
        }
      } else {
        $scope.toastShow("找不到" + keepData + "的商品信息");
        popup.alert({
          template : "<div class='tc'>"+"找不到" + keepData + "的商品信息"+"</div>",
          okText : "确定"
        });
      }
    }, function() {
      $scope.toastShow("扫码获取商品信息失败");
    });
  };
  /**
   * @return {undefined}
   */
  self.searchGoods = function() {
    /** @type {number} */
    pageNum = 1;
    createDom({
      page : pageNum,
      searchKey : self.search.goodKey
    }).success(function(info) {
      self.KEY288 = info.optionList;
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
      if (T) {
        if (1 === self.KEY288.length) {
          self.KEY264(self.KEY288[0]);
        } else {
          self.openSearch();
          /** @type {boolean} */
          self.isFromScanToAddGoodsTrend = true;
        }
        /** @type {boolean} */
        T = false;
      }
    }).finally(function() {
      parent.scrollTop("mainGoodListScroll");
    });
  };
  var throttledUpdate = ionic.debounce(self.searchGoods, 500);
  /**
   * @return {undefined}
   */
  self.searchGoodsByKeyword = function() {
    throttledUpdate();
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    createDom({
      page : ++pageNum,
      searchKey : self.search.goodKey
    }).success(function(info) {
      self.KEY288 = self.KEY288.concat(info.optionList);
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
    }).finally(function() {
      parent.resize("mainGoodListScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.goodComfirmSearch = function() {
    /** @type {boolean} */
    T = false;
    self.searchGoods();
  };
  /**
   * @return {undefined}
   */
  self.clearSearch = function() {
    /** @type {string} */
    self.search.goodKey = "";
    /** @type {string} */
    self.search.focused_good = "centered_main";
    $scope.keyboardHide();
    self.goodComfirmSearch();
  };
  /**
   * @return {undefined}
   */
  self.cancleSearch = function() {
    select(function() {
      /** @type {(Element|null)} */
      var tapElement = document.querySelector("#mainGoodSearchInput");
      if (tapElement) {
        if (tapElement.blur) {
          tapElement.blur();
        }
      }
      /** @type {boolean} */
      self.search.show = false;
    });
  };
  /**
   * @return {undefined}
   */
  self.openSearch = function() {
    select(function() {
      /** @type {(Element|null)} */
      var submenu = document.querySelector("#mainGoodSearchInput");
      if (submenu) {
        if (submenu.focus) {
          submenu.focus();
        }
      }
    });
    /** @type {string} */
    self.search.focused_good = "text-left";
    /** @type {boolean} */
    self.search.show = true;
    callback = ignoreMethodDoesntExist.registerBackButtonAction(function() {
      return(callback || angular.noop)(), self.cancleSearch(), false;
    }, 140, "mainBackButtonAction");
  };
  /**
   * @param {?} userId
   * @param {?} done
   * @return {undefined}
   */
  scope.gotoAppFunc = function(userId, done) {
    if (userId) {
      if (done) {
        context.go(userId, done);
      } else {
        context.go(userId);
      }
    }
  };
  /**
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  var put = function(dataAndEvents) {
    if (!$templateCache.get("slideBoxTemplate.html") || dataAndEvents) {
      defer.then(function(failures) {
        /** @type {string} */
        var template = "<ion-slide-box delegate-handle='main-slide-box' does-continue='true' auto-play='true' show-pager='false'>";
        failures.forEach(function(req) {
          /** @type {string} */
          var optsData = "";
          if (optsData = req.openInApp ? "openLink('" + (req.link ? req.link : "") + "',true)" : "openLink('" + (req.link ? req.link : "") + "')", req.isInApp) {
            /** @type {string} */
            var messageFormat = JSON.stringify(req.param);
            if (messageFormat) {
              /** @type {string} */
              messageFormat = messageFormat.replace(/\"/g, "'");
            }
            /** @type {string} */
            optsData = "gotoAppFunc('" + (req.link ? req.link : "") + "'," + messageFormat + ")";
          }
          template += "<ion-slide><img ng-src='" + current.imgServer + req.url + "?random=" + $scope.getTimeStamp() + "' width='100%' height='100%' on-tap=\"" + optsData + '"></ion-slide>';
        });
        template += "</ion-slide-box>";
        $templateCache.put("slideBoxTemplate.html", template);
        /** @type {string} */
        self.slideBoxTemplate = "slideBoxTemplate.html";
      });
    } else {
      /** @type {string} */
      self.slideBoxTemplate = "slideBoxTemplate.html";
    }
  };
  /**
   * @return {undefined}
   */
  var bootstrap = function() {
    if (window.cordova) {
      if (ionic.Platform.isIOS()) {
        window.plugins.updateApp.checkVersion(function(dataAndEvents) {
          if (1 == dataAndEvents) {
            $scope.showConfirm("建议您前往App Store进行更新", function(dataAndEvents) {
              if (2 === dataAndEvents) {
                window.open("itms-apps://itunes.apple.com/cn/app/xxxxxxxxxxxxxxxxxxx/id0000000000000", "_system");
              }
            }, "发现新版本", ["忽略", "前往App Store"]);
          } else {
            if (2 == dataAndEvents) {
              $scope.showAlert("重要更新，将跳转至App Store更新", function() {
                window.open("itms-apps://itunes.apple.com/cn/app/xxxxxxxxxxxxxxxxxxx/id0000000000000", "_system");
              }, "发现新版本", "确认");
            } else {
              $scope.appHotUpdateSilent();
            }
          }
        }, null, current.versionServer);
      } else {
        $scope.appHotUpdateSilent();
      }
    }
  };
  self.$on("$ionicView.beforeEnter", function() {
    self.dragMenu(true);
    put();
    self.checkMenus = scope.mainUserConfig && scope.mainUserConfig.mobileHomeCfg ? scope.mainUserConfig.mobileHomeCfg.split(",") : ["KEY329","KEY220","KEY338","KEY332","KEY333","KEY336","KEY257","KEY258"];
    if (1 == $window.localStorage.isBLEPrinted) {
      /** @type {number} */
      $window.localStorage.isBLEPrinted = 0;
      select(function() {
        window.plugins.bluetoothPrinter.close(angular.noop, angular.noop);
      }, 1E3);
    }
  });
  self.$on("$ionicView.afterEnter", function() {
    select(function() {
      /** @type {boolean} */
      scope.hideTabs = false;
    });
    ret.httpCacheGet.lruCache.removeAll();
    if (scope.isRefreshGoodsListForMain === true) {
      self.searchGoods();
      /** @type {boolean} */
      scope.isRefreshGoodsListForMain = false;
    }
    /** @type {number} */
    var timeStampToRefresh = Math.round($scope.getTimeStamp() / 1E3);
    if ($window.localStorage.timeStampToRefresh && timeStampToRefresh - $window.localStorage.timeStampToRefresh >= 1800) {
      /** @type {number} */
      $window.localStorage.timeStampToRefresh = timeStampToRefresh;
      self.getFeatureModule("refresh");
      put(true);
      bootstrap();
    } else {
      if (!$window.localStorage.timeStampToRefresh) {
        /** @type {number} */
        $window.localStorage.timeStampToRefresh = timeStampToRefresh;
        bootstrap();
      }
    }
    $document.getScanerCode(function(key) {
      self.searchGoodsByBarCode(key);
    }, self.bluethoothScaner);
  });
  self.$on("$ionicView.beforeLeave", function() {
    self.dragMenu(false);
    /** @type {string} */
    self.slideBoxTemplate = "";
    if (!context.includes("eventmenu.KEY225")) {
      /** @type {boolean} */
      self.search.show = false;
    }
    (callback || angular.noop)();
    select(context.includes("eventmenu.KEY281") || (context.includes("eventmenu.KEY286") || (context.includes("eventmenu.KEY202") || (context.includes("eventmenu.KEY294") || context.includes("eventmenu.main")))) ? function() {
      /** @type {boolean} */
      scope.hideTabs = false;
    } : function() {
      /** @type {boolean} */
      scope.hideTabs = true;
    });
  });
  /**
   * @return {undefined}
   */
  self.openQqWindow = function() {
    window.open(self.mainInstruction.url, "_system");
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.goHelpChart = function(dataAndEvents) {
    if (dataAndEvents) {
      poster.hide();
    }
    /** @type {string} */
    var href = "http://app.xinbafar.com.cn:8080/business/mms/m/help/college.html?userId=" + scope.mainUserConfig.userId + "&cid=" + scope.mainUserConfig.cid;
    self.openLink(href, 1);
  };
  /**
   * @return {undefined}
   */
  self.goBusinessCommunity = function() {
    self.openLink(current.mmsServer + "/information/informationMain.ac?userId=" + scope.mainUserConfig.userId + "&cid=" + scope.mainUserConfig.cid, 1);
  };
  /**
   * @return {undefined}
   */
  self.goToActivity = function() {
    if (self.activityConfig.openLink ? self.activityConfig.isInApp ? self.openLink(self.activityConfig.link, true) : self.openLink(self.activityConfig.link) : self.activityConfig.param ? context.go(self.activityConfig.link, self.activityConfig.param) : context.go(self.activityConfig.link), self.activityModal.hide(), self.activityConfig && self.activityConfig.issueIds) {
      /** @type {string} */
      var rreturn = current.mgrServer + "/KEY434";
      ret.fullPathPostEncode(rreturn, {
        issueIds : self.activityConfig.issueIds
      }).success(function(dataAndEvents) {
        if (1 !== dataAndEvents) {
          console.error("领取礼包异常！");
        }
      });
      $.get(self.logPath + "receiveVoucher");
    }
  };
  $modal.fromTemplateUrl("activity.html", function(theTitle) {
    /** @type {number} */
    self.activityModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.closeActivityModal = function() {
    self.activityModal.hide();
  };
  self.$on("$destroy", function() {
    self.activityModal.remove();
  });
  /**
   * @return {undefined}
   */
  var init = function() {
    var SESSION_ISFIRSTLOGIN = sessionStorage.getItem("SESSION_ISFIRSTLOGIN");
    if ("1" != SESSION_ISFIRSTLOGIN) {
      /** @type {boolean} */
      self.isEx = false;
      ret.post("/KEY104").success(function(dataAndEvents) {
        /**
         * @param {?} doc
         * @return {undefined}
         */
        function init(doc) {
          var defaultView = doc.activityCode;
          if (doc.isOpen) {
            if (!$window.localStorage.activityCode || defaultView > $window.localStorage.activityCode) {
              select(function() {
                var px = self.platformIsPad ? doc.padUrl : doc.phoneUrl;
                self.imgUrl = current.imgServer + px + "?random=" + $scope.getTimeStamp();
                self.activityModal.show();
              });
              $window.localStorage.activityCode = defaultView;
            }
          }
        }
        deepDataAndEvents.getActivityConfig().then(function(theTitle) {
          if (self.activityConfig = theTitle, self.activityConfig && self.activityConfig.issueIds) {
            /** @type {string} */
            var rreturn = current.mgrServer + "/KEY442";
            ret.fullPathPostEncode(rreturn, {
              issueIds : self.activityConfig.issueIds
            }).success(function(res) {
              if (res.object) {
                if (0 == res.object.status) {
                  init(self.activityConfig);
                }
              }
            });
          } else {
            init(self.activityConfig);
          }
        });
      }).error(function() {
        console.error("获取用户是否第一次登录信息异常！");
      });
    }
  };
  self.$on("$ionicView.loaded", function() {
    return self.searchGoods(), self.menuList = theTitle, dataAndEvents.isAutoLogin && "true" == $window.localStorage.isEnableGesturePwd ? (context.go("gestureUnLock"), false) : (self.handleAppUrl(), void init());
  });
}]).controller("MainUserDefinedCtrl", ["$scope", "$rootScope", "Menu", "$ionicModal", "psisServices", "lbScrollDelegate", function(scope, options, defs, dataAndEvents, args, $window) {
  scope.checkMenus = options.mainUserConfig && options.mainUserConfig.mobileHomeCfg ? options.mainUserConfig.mobileHomeCfg.split(",") : ["KEY329","KEY220","KEY338","KEY332","KEY333","KEY336","KEY257","KEY258"];
  scope.data = {
    showReorder : false
  };
  scope.menuList = {};
  /** @type {Array} */
  scope.allSelectMenuList = [];
  /** @type {Array.<string>} */
  var required = Object.keys(defs);
  /** @type {number} */
  var i = 0;
  /** @type {number} */
  var l = required.length;
  for (;l > i;i++) {
    /** @type {string} */
    var key = required[i];
    if (scope.GetOperatorEventLimit(defs[key].authority) || !defs[key].authority) {
      scope.menuList[key] = defs[key];
      scope.allSelectMenuList.push(key);
    }
  }
  /** @type {Array} */
  scope.itemList = scope.allSelectMenuList;
  /**
   * @param {string} elements
   * @return {?}
   */
  scope.menuKeys = function(elements) {
    return elements ? Object.keys(elements) : [];
  };
  scope.$watchCollection("checkMenus", function(newValue, expected) {
    if (options.mainUserConfig) {
      if (!angular.equals(newValue, expected)) {
        options.mainUserConfig.mobileHomeCfg = newValue.toString();
      }
    }
  });
  /**
   * @return {undefined}
   */
  scope.switchToSort = function() {
    /** @type {boolean} */
    scope.data.showReorder = true;
    scope.itemList = scope.checkMenus;
    $window.scrollTop("MainUserDefinedCtrlScroll");
  };
  /**
   * @return {undefined}
   */
  scope.switchToSelect = function() {
    /** @type {boolean} */
    scope.data.showReorder = false;
    scope.itemList = scope.allSelectMenuList;
    $window.scrollTop("MainUserDefinedCtrlScroll");
  };
  scope.$on("$destroy", function() {
    if (options.mainUserConfig) {
      args.post("/KEY259", options.mainUserConfig).success(function(res) {
        if (1 === res.statusCode) {
          options.mainUserConfig = res.object;
        }
      });
    }
    $window.scrollTop("mainUserDefinedScroll");
  });
  scope.$on("$ionicView.beforeLeave", function() {
    scope.finishSelected();
  });
  /**
   * @param {string} item
   * @return {undefined}
   */
  scope.selectMenu = function(item) {
    var ix = scope.checkMenus.indexOf(item);
    if (ix > -1) {
      scope.checkMenus.splice(ix, 1);
    } else {
      scope.checkMenus.push(item);
    }
  };
  /**
   * @param {?} block
   * @param {?} r2
   * @param {?} index
   * @return {undefined}
   */
  scope.reorderMenu = function(block, r2, index) {
    scope.checkMenus.splice(r2, 1);
    scope.checkMenus.splice(index, 0, block);
  };
  /**
   * @return {undefined}
   */
  scope.finishSelected = function() {
    /** @type {number} */
    var idx = 0;
    var cnl = scope.checkMenus.length;
    for (;cnl > idx;idx++) {
      var next = scope.checkMenus[idx];
      var timeout = scope.allSelectMenuList.indexOf(next);
      if (0 > timeout) {
        scope.checkMenus.splice(idx, 1);
      }
    }
  };
}]).controller("StoreTabCtrl", ["$scope", "$rootScope", "$state", "Tools", "$timeout", "Menu", "$window", "BTScanerService", "psisServices", "$filter", "$q", "ServerConfig", function(scope, deepDataAndEvents, $state, ignoreMethodDoesntExist, $sanitize, transclude, textAlt, dataAndEvents, keepData, opt_attributes, matcherFunction) {
  scope.menuList = transclude;
  scope.queryCondition = {
    listDataType : 1,
    existsNumber : 1
  };
  scope.$on("$ionicView.afterEnter", function() {
    $sanitize(function() {
      /** @type {boolean} */
      deepDataAndEvents.hideTabs = false;
    });
    dataAndEvents.getScanerCode(function(fmt) {
      console.log(fmt);
    }, scope.bluethoothScaner);
  });
  /**
   * @return {undefined}
   */
  scope.goToStockWarnList = function() {
    if (scope.depot) {
      $state.go("eventmenu.KEY207", {
        saleDepot : scope.depot
      });
    } else {
      $state.go("eventmenu.KEY207");
    }
  };
  scope.$on("$ionicView.loaded", function() {
  });
}]).controller("SaleTabCtrl", ["$scope", "$rootScope", "$state", "Tools", "$timeout", "Menu", "$window", "BTScanerService", "VaApplyItem", "$ionicPopup", "ServerConfig", function(scope, ignoreMethodDoesntExist, $state, dataAndEvents, $sanitize, transclude, $window, deepDataAndEvents, textAlt) {
  scope.menuList = transclude;
  scope.$on("$ionicView.afterEnter", function() {
    $sanitize(function() {
      /** @type {boolean} */
      ignoreMethodDoesntExist.hideTabs = false;
    });
    deepDataAndEvents.getScanerCode(function(fmt) {
      console.log(fmt);
    }, scope.bluethoothScaner);
    if (1 == $window.localStorage.isBLEPrinted) {
      /** @type {number} */
      $window.localStorage.isBLEPrinted = 0;
      $sanitize(function() {
        window.plugins.bluetoothPrinter.close(angular.noop, angular.noop);
      }, 1E3);
    }
    if (scope.platformIsIOS) {
      if (!$window.localStorage.goToAppStoreShow) {
        if ($window.localStorage.appInstallTime) {
          if (Math.round(dataAndEvents.getTimeStamp() / 1E3) - $window.localStorage.appInstallTime >= 172800) {
            dataAndEvents.showConfirm("亲，喜欢辛巴手机版么？给我们打打气，鼓励下吧", function(dataAndEvents) {
              if (2 === dataAndEvents) {
                scope.openLink("itms-apps://itunes.apple.com/cn/app/xxxxxxxxxxxxxxxxxxx/id0000000000000");
              }
              /** @type {number} */
              $window.localStorage.goToAppStoreShow = 1;
            }, "给个好评", ["忽略", "赞一个"]);
          }
        }
      }
    }
  });
  /**
   * @return {undefined}
   */
  scope.goToPartner = function() {
    $state.go("eventmenu.KEY245");
  };
  scope.$on("$ionicView.beforeEnter", function() {
  });
  /**
   * @return {undefined}
   */
  scope.aForAccResourceForShop = function() {
    scope.openLinkInIframe(textAlt.getVaItem[2].title, textAlt.getVaItem[2].htmlName);
  };
}]).controller("StatisticsTabCtrl", ["$scope", "$rootScope", "$state", "Tools", "$timeout", "Menu", "$window", "BTScanerService", "psisServices", "$filter", "commonDataInterface", "ServerConfig", function(scope, deepDataAndEvents, ignoreMethodDoesntExist, dojo, $sanitize, transclude, textAlt, dataAndEvents, $http, $filter, shims, obj) {
  /**
   * @return {undefined}
   */
  function send() {
    if (scope.banlanceAmountSum = "...", scope.GetOperatorEventLimit("KEY153")) {
      /** @type {Date} */
      var now = new Date;
      now.setHours(0, 0, 0, 0);
      /** @type {Date} */
      var date = new Date;
      date.setHours(23, 59, 59);
      var customer = {
        createTimeBegin : $filter("date")(now, "yyyy-MM-ddTHH:mm:ss.sssZ"),
        createTimeEnd : $filter("date")(date, "yyyy-MM-ddTHH:mm:ss.sssZ")
      };
      $http.post("/KEY018", customer).success(function(res) {
        if (1 == res.statusCode) {
          scope.banlanceAmountSum = res.object.banlanceAmountSum.toFixed(2);
        } else {
          dojo.toastShow(res.content);
        }
      });
    }
  }
  /**
   * @return {undefined}
   */
  function process() {
    if (scope.GetOperatorEventLimit("KEY150")) {
      /** @type {Date} */
      var now = new Date;
      now.setHours(0, 0, 0, 0);
      /** @type {Date} */
      var date = new Date;
      date.setHours(23, 59, 59);
      var customer = {
        beginTime : $filter("date")(now, "yyyy-MM-ddTHH:mm:ss.sssZ"),
        endTime : $filter("date")(date, "yyyy-MM-ddTHH:mm:ss.sssZ")
      };
      /** @type {boolean} */
      scope.sumDataLoading = true;
      $http.post("/KEY167", customer).success(function(data) {
        scope.saleNumber = data.saleNumber;
        scope.sumTrueAmount = data.sumTrueAmount.toFixed(2);
      }).finally(function() {
        /** @type {boolean} */
        scope.sumDataLoading = false;
      });
    } else {
      /** @type {string} */
      scope.saleNumber = "**";
      /** @type {string} */
      scope.sumTrueAmount = "**";
      /** @type {boolean} */
      scope.sumDataLoading = false;
    }
  }
  scope.menuList = transclude;
  /** @type {string} */
  var object = "banlanceAmountSumShowed";
  scope.$on("$ionicView.afterEnter", function() {
    $sanitize(function() {
      /** @type {boolean} */
      deepDataAndEvents.hideTabs = false;
    });
    dataAndEvents.getScanerCode(function(fmt) {
      console.log(fmt);
    }, scope.bluethoothScaner);
  });
  /**
   * @param {?} value
   * @return {undefined}
   */
  scope.toggleShow = function(value) {
    if (value) {
      value.stopPropagation();
    }
    /** @type {number} */
    scope.banlanceAmountSumShowed.configValue = 0 == scope.banlanceAmountSumShowed.configValue ? 1 : 0;
    shims.saveOrUpdateUserConfig(object, scope.banlanceAmountSumShowed.configValue).then(function(line) {
      var fullMessage = dojo.fnCheckGtoreQty(obj.userConfigData, "configKey", object);
      if (void 0 !== fullMessage) {
        /** @type {number} */
        fullMessage.configValue = 0 == line.object.configValue ? 0 : 1;
      } else {
        obj.userConfigData.push(line.object);
      }
    }, function() {
      console.log("保存记忆选项不成功！");
    });
  };
  scope.$on("$ionicView.loaded", function() {
    send();
    process();
    scope.banlanceAmountSumShowed = dojo.fnCheckGtoreQty(obj.userConfigData, "configKey", "banlanceAmountSumShowed");
    if (void 0 === scope.banlanceAmountSumShowed) {
      scope.banlanceAmountSumShowed = {};
      /** @type {number} */
      scope.banlanceAmountSumShowed.configValue = 0;
    } else {
      /** @type {number} */
      scope.banlanceAmountSumShowed.configValue = 0 == scope.banlanceAmountSumShowed.configValue ? 0 : 1;
    }
  });
}]).controller("AccountCenterTabCtrl", ["$scope", "$rootScope", "$state", "Tools", "$timeout", "Menu", "$window", "ServerConfig", "psisServices", "BTScanerService", "VaApplyItem", function(self, elementData, $state, dataAndEvents, $sanitize, theTitle, $window, deepDataAndEvents, ret, $document, ignoreMethodDoesntExist) {
  self.menuList = theTitle;
  self.ac = {
    balance : "0.00",
    voucherNum : 0,
    collectionAmount : "0.00"
  };
  self.ac.logo = elementData.mainCompany && elementData.mainCompany.logo ? elementData.mainCompany.logo : "img/PicService/default_logo.png";
  self.KEY196 = {
    realName : ".."
  };
  self.$on("$ionicView.afterEnter", function() {
    $sanitize(function() {
      /** @type {boolean} */
      elementData.hideTabs = false;
    });
    $document.getScanerCode(function(fmt) {
      console.log(fmt);
    }, self.bluethoothScaner);
    if (1 == $window.localStorage.isBLEPrinted) {
      /** @type {number} */
      $window.localStorage.isBLEPrinted = 0;
      $sanitize(function() {
        window.plugins.bluetoothPrinter.close(angular.noop, angular.noop);
      }, 1E3);
    }
    if (self.platformIsIOS) {
      if (!$window.localStorage.goToAppStoreShow) {
        if ($window.localStorage.appInstallTime) {
          if (Math.round(dataAndEvents.getTimeStamp() / 1E3) - $window.localStorage.appInstallTime >= 172800) {
            dataAndEvents.showConfirm("亲，喜欢辛巴生进销存么？给我们打打气，鼓励下吧", function(dataAndEvents) {
              if (2 === dataAndEvents) {
                self.openLink("itms-apps://itunes.apple.com/cn/app/xxxxxxxxxxxxxxxxxxx/id0000000000000");
              }
              /** @type {number} */
              $window.localStorage.goToAppStoreShow = 1;
            }, "给个好评", ["忽略", "赞一个"]);
          }
        }
      }
    }
  });
  /**
   * @param {string} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    /** @type {string} */
    var rreturn = deepDataAndEvents.mgrServer + "/KEY249";
    return ret.fullPathPostEncode(rreturn, opt_attributes);
  };
  /**
   * @return {?}
   */
  var $http = function() {
    /** @type {string} */
    var rreturn = deepDataAndEvents.mgrServer + "/KEY106";
    return ret.fullPathPostEncode(rreturn);
  };
  /**
   * @return {undefined}
   */
  var send = function() {
    if (self.GetOperatorEventLimit("KEY085")) {
      ret.post("/KEY250").success(function(res) {
        if (1 == res.statusCode) {
          if (res.object) {
            if (res.object.proxyAccountVO) {
              self.ac.collectionAmount = res.object.proxyAccountVO.balance ? res.object.proxyAccountVO.balance : "0.00";
            }
          }
        }
      });
    } else {
      /** @type {string} */
      self.ac.collectionAmount = "0.00";
    }
  };
  /**
   * @return {undefined}
   */
  self.getVoucherNum = function() {
    createDom({
      page : pageNum
    }).success(function(operation) {
      if (operation.records) {
        self.ac.voucherNum = operation.records;
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.getBalance = function() {
    $http({
      page : pageNum
    }).success(function(balance) {
      self.ac.balance = balance.balance ? balance.balance : "0.00";
    });
  };
  /**
   * @return {undefined}
   */
  self.gotoReCharge = function() {
    self.openLinkInIframe("账户充值", deepDataAndEvents.mgrServer + "/trade/rechargePageOnMobile.ac?clientType=app");
  };
  /**
   * @return {undefined}
   */
  self.gotoVoucher = function() {
    $state.go("eventmenu.KEY254");
  };
  /**
   * @param {?} event
   * @return {?}
   */
  self.gotoMember = function(event) {
    return event.stopPropagation() && event.preventDefault(), self.openLinkInIframe(ignoreMethodDoesntExist.getVaItem[3].title, ignoreMethodDoesntExist.getVaItem[3].htmlName), false;
  };
  /**
   * @return {undefined}
   */
  self.gotoBalance = function() {
    $state.go("eventmenu.KEY279");
  };
  /**
   * @return {?}
   */
  self.gotoCollection = function() {
    return self.GetOperatorEventLimit("KEY064") ? void $state.go("eventmenu.collection") : (dataAndEvents.toastShow("此子账户没提现的权限"), false);
  };
  /**
   * @return {undefined}
   */
  self.gotoVaService = function() {
    $state.go("eventmenu.KEY244");
  };
  /**
   * @return {undefined}
   */
  self.gotoMyVaService = function() {
    $state.go("eventmenu.KEY246");
  };
  /**
   * @return {undefined}
   */
  self.gotoAccountCenter = function() {
    $state.go("eventmenu.KEY274");
  };
  /**
   * @return {undefined}
   */
  self.getUserInfo = function() {
    ret.post("/KEY234").success(function(reply) {
      self.KEY196 = reply.object;
    });
  };
  self.$on("$ionicView.loaded", function() {
    self.getVoucherNum();
    self.getBalance();
    self.getUserInfo();
    send();
  });
}]).controller("GestureLockCtrl", ["$scope", "$state", "$stateParams", "Tools", "$timeout", "Menu", "$window", "GestureLockService", "$ionicPopup", function(self, app, event, dataAndEvents, cb, deepDataAndEvents, options, FastClick, _) {
  var type = event.type;
  /** @type {string} */
  self.viewTitle = "解锁";
  if ("set" == type) {
    /** @type {string} */
    self.viewTitle = "设置手势密码";
  } else {
    if ("reset" == type) {
      /** @type {string} */
      self.viewTitle = "修改手势密码";
    } else {
      if (!type) {
        /** @type {boolean} */
        self.needToUnLock = true;
      }
    }
  }
  /** @type {string} */
  self.msg = "绘制解锁图案";
  /**
   * @return {?}
   */
  var loadFromStorage = function() {
    return JSON.parse(options.localStorage.getItem("GestureLockPassword"));
  };
  /**
   * @param {?} data
   * @return {undefined}
   */
  var callback = function(data) {
    options.localStorage.setItem("GestureLockPassword", JSON.stringify(data));
    options.localStorage.setItem("isEnableGesturePwd", true);
  };
  var entries = loadFromStorage();
  /** @type {boolean} */
  var p = false;
  /** @type {Array} */
  var args = [2];
  /** @type {number} */
  var i = 1;
  /** @type {number} */
  var v = 3;
  /** @type {(HTMLElement|null)} */
  var layer = document.getElementById("KEY236");
  /** @type {number} */
  layer.width = 300;
  /** @type {number} */
  layer.height = layer.width;
  var $ = new FastClick(layer, {
    matrix : 3
  });
  if (!("reset" != type)) {
    if (!p) {
      /** @type {string} */
      self.msg = "绘制旧解锁图案";
    }
  }
  /**
   * @return {undefined}
   */
  var done = function() {
    /** @type {string} */
    options.localStorage.password = "";
    options.localStorage.setItem("isEnableGesturePwd", false);
    app.go("signin");
  };
  /**
   * @return {undefined}
   */
  var init = function() {
    if ($.validatePassword(entries, $.getGesturePassword())) {
      $.viewStatus("success", {
        ring : true
      });
      if ("reset" == type) {
        /** @type {string} */
        self.msg = "绘制新的解锁图案";
        cb(function() {
          /** @type {boolean} */
          p = true;
          $.reset();
        }, 500);
      } else {
        if ("clear" == type) {
          /** @type {string} */
          self.msg = "关闭手势密码成功";
          options.localStorage.setItem("isEnableGesturePwd", false);
          cb(function() {
            $.reset();
            self.goBack();
          }, 1E3);
        } else {
          /** @type {string} */
          self.msg = "解锁成功";
          cb(function() {
            $.reset();
            self.goBack();
          }, 1E3);
        }
      }
    } else {
      $.viewStatus("error", {
        ring : true
      });
      v--;
      /** @type {string} */
      self.msg = "手势密码错误，还能输入" + v + "次";
      cb(function() {
        $.reset();
        if (0 == v) {
          options.localStorage.setItem("isEnableGesturePwd", false);
          dataAndEvents.toastShow("密码错误次数过多，请重新登录");
          done();
        }
      }, 500);
    }
  };
  /**
   * @return {?}
   */
  var reset = function() {
    return args[i % 2] = $.getGesturePassword(), args[i % 2].length < 4 ? (self.msg = "手势密码少于4位", $.viewStatus("error", {
      ring : true
    }), cb(function() {
      $.reset();
    }, 500), false) : (i % 2 === 1 ? ($.viewStatus("success", {
      ring : true
    }), self.msg = "reset" == type ? "请再次绘制新解锁图案" : "请再次绘制解锁图案", cb(function() {
      $.reset();
    }, 500)) : i % 2 === 0 && ($.validatePassword(args[0], args[1]) ? ($.viewStatus("success", {
      ring : true
    }), callback(args[0]), self.msg = "reset" == type ? "修改手势密码成功" : "已保存手势密码", dataAndEvents.toastShow("手势密码设置成功"), cb(function() {
      $.reset();
      self.goBack();
    }, 1E3)) : (self.msg = "与上次绘制不一致，请重新绘制", $.viewStatus("error", {
      ring : true
    }), cb(function() {
      $.reset();
    }, 500))), void++i);
  };
  /**
   * @return {undefined}
   */
  $.gestureEnd = function() {
    if ("reset" == type) {
      if (p) {
        reset();
      } else {
        init();
      }
    } else {
      if ("set" == type) {
        reset();
      } else {
        init();
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.exitGesturePwd = function() {
    self.goBack();
  };
  /**
   * @return {undefined}
   */
  self.forgetPwd = function() {
    if (window.cordova && window.cordova.plugins) {
      dataAndEvents.showConfirm("忘记手势密码，需要重新登录", function(dataAndEvents) {
        if (2 == dataAndEvents) {
          done();
        }
      }, null, ["取消", "确认"]);
    } else {
      var promise = _.confirm({
        template : "<div class='tc'>忘记手势密码，需要重新登录</div>",
        cancelText : "取消",
        okText : "确认"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          done();
        }
      });
    }
  };
  self.$on("$ionicView.loaded", function() {
    $.init();
  });
}]).controller("CommonIFrameCtrl", ["$scope", "$state", "Tools", "$timeout", "$window", "$stateParams", "$sce", "HandleMessageService", "ServerConfig", "wechatShare", "qqShare", "$ionicModal", function($scope, dataAndEvents, deepDataAndEvents, ignoreMethodDoesntExist, textAlt, e, $sce, socket, current, test, self, $modal) {
  if ($scope.title = e.title, $scope.currentUrl = e.currentUrl, $scope.isSharable = e.isSharable, -1 == e.currentUrl.indexOf("//")) {
    var staticOffset = current.currentServer.replace("/is", "").replace("ex.", "www.").replace("web.", "www.");
    $scope.currentUrl = staticOffset + e.currentUrl;
  }
  $scope.currentUrl = $sce.trustAsResourceUrl($scope.currentUrl);
  /** @type {string} */
  var android = $scope.platformIsAndroid ? "android" : "ios";
  /** @type {string} */
  var file = "&userid=" + $scope.mainUserConfig.userId + "&cid=" + $scope.mainUserConfig.cid + "&client=isapp&agent=" + android + "&topic=CommonIFrameCtrl&log=";
  /** @type {string} */
  var path = "https://xinba-log.log.aliyuncs.com/logstores/log_store_tracking/track?APIVersion=0.6.0" + file;
  $.get(path + $scope.title);
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  $scope.share = function(opt_attributes) {
    /** @type {string} */
    var queueHooks = "&userid=" + $scope.mainUserConfig.userId + "&cid=" + $scope.mainUserConfig.cid + "&client=isapp&agent=" + android + "&topic=CommonIFrameShare&log=";
    /** @type {string} */
    var key = "https://xinba-log.log.aliyuncs.com/logstores/log_store_tracking/track?APIVersion=0.6.0" + queueHooks;
    var k = e.shareImgUrl;
    var form = e.currentUrl;
    if ("Timeline" == opt_attributes) {
      key += "Timeline";
      test.shareUrlToTimeline(form, e.title, e.description, k);
    } else {
      if ("friend" == opt_attributes) {
        key += "friend";
        test.shareUrlToSession(form, e.title, e.description, k);
      } else {
        if ("qq" == opt_attributes) {
          key += "qq";
          self.shareUrlToQq(form, e.title, e.description, k);
        } else {
          if ("qz" == opt_attributes) {
            key += "qz";
            /** @type {Array} */
            var progressValues = [];
            progressValues.push(k);
            self.shareUrlToQz(form, e.title, e.description, progressValues);
          }
        }
      }
    }
    $.get(key);
  };
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY040.html", function($location) {
    $scope.KEY263 = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  $scope.openShareModal = function() {
    $.get($scope.logPath + "mainShare");
    $scope.KEY263.show();
  };
  /**
   * @param {Object} event
   * @return {undefined}
   */
  var completed = function(event) {
    socket.handleMessage(event, $scope);
  };
  window.addEventListener("message", completed, false);
  $scope.$on("$destroy", function() {
    window.removeEventListener("message", completed, false);
    $scope.KEY263.remove();
  });
  $scope.$on("$ionicView.loaded", function() {
    if (window.cordova) {
      if ("undefined" != typeof MobclickAgent) {
        MobclickAgent.onEventWithParameters("openInIFrame", {
          link : e.currentUrl
        });
      }
    }
  });
}]).directive('popupKeyBoardShow', [function ($rootScope, $ionicPlatform, $timeout, $ionicHistory, $cordovaKeyboard) {
  return {
    link: function (scope, element, attributes) {
      window.addEventListener('native.keyboardshow', function (e) {
        angular.element(element).parent().parent().css({
          'margin-top': '-' + 80 + 'px'   //这里80可以根据页面设计，自行修改
        })
      })

      window.addEventListener('native.keyboardhide', function (e) {
        angular.element(element).parent().parent().css({
          'margin-top': 0
        })
      })
    }
  }
}]);
